	local L = LibStub("AceLocale-3.0"):GetLocale("sqwNameplates")
	local LSM = LibStub("LibSharedMedia-3.0")
	local db
	local t,t2 = nil

	--[[ Print ]]
	local function p(text)
		ChatFrame3:AddMessage(tostring(text))
	end

	local realmName = GetRealmName()
	local realm
	local resources = sqwNameplates.resources


	local function processOldData()
		local s
		
		local spellList = sqwNameplates.db.global.spellList
		for index,value in pairs(spellList) do
			if type(value)=="table" then
				s = sqwNameplates:Serialize(value.icon, value.duration and value.duration > 0 and resources.round(value.duration, 1))
				
				spellList[index] = s
			end
		end
		
		local playerList = realm.playerList
		for index,value in pairs(playerList) do
			if type(value)=="table" then
				s = sqwNameplates:Serialize(value.GUID, value.name, value.class, value.guild, value.realm)
				
				playerList[index] = s
			end
		end
		
		realm.guildList = nil
		
		db.dConverted = 1
	end

	--ON COMMAND
	function sqwNameplates:Command(param)
		sqwNameplates.optionFrame.main:Show()
		
		--InterfaceOptionsFrame_OpenToCategory("sqwNameplates")
	end

	--ON INITIALIZE
	function sqwNameplates:OnInitialize()
		
		SetCVar("bloattest", 1)
		-- SetCVar("spreadnameplates", 0)
		SetCVar("bloatnameplates", 0)--orig do not alter aquired target np size
		--SetCVar("bloatnameplates", 1)--increases size of aquired target np
		SetCVar("bloatthreat", 0)
		--SetCVar("ShowClassColorInNameplate",1)
		SetCVar("showVKeyCastbar",1)
		SetCVar("nameplateShowFriends", 0)
		SetCVar("nameplateShowFriendlyGuardians", 0)
		
		--DB
		self.db = LibStub("AceDB-3.0"):New("sqwNameplatesDB", self.defaults)
		self.db.RegisterCallback(self, "OnProfileChanged", sqwNameplates.OnProfileChange)
		self.db.RegisterCallback(self, "OnProfileCopied", sqwNameplates.OnProfileChange)
		self.db.RegisterCallback(self, "OnProfileReset", sqwNameplates.OnProfileChange)
		self.db.RegisterCallback(self, "OnProfileDeleted", sqwNameplates.OnProfileChange)
		
		--OPTIONS
		self:SpawnOptions()
		if self.options then
			LibStub("AceConfig-3.0"):RegisterOptionsTable("sqwNameplates", self.options)
			LibStub("AceConfigDialog-3.0"):AddToBlizOptions("sqwNameplates", "sqwNameplates")
		end
		
		--PROFILES
		local AceDBOptions = LibStub("AceDBOptions-3.0", true)
		if self.options and AceDBOptions then
			self.options.args.profiles = AceDBOptions:GetOptionsTable(self.db)
			self.options.args.profiles.order = 999
		end
		
		--COMMAND
		self:RegisterChatCommand("sqwnp", "Command")
		self:RegisterChatCommand("np", "Command")
		
		--LIB SHARED MEDIA
		LSM:Register("font", "Segoe UI",					        [[Interface\Addons\sqwNameplates\media\font\segoe_ui.ttf]])
		LSM:Register("font", "Segoe UI Bold",					    [[Interface\Addons\sqwNameplates\media\font\segoe_ui_bold.ttf]])
		LSM:Register("font", "Segoe UI Italic",					    [[Interface\Addons\sqwNameplates\media\font\segoe_ui_italic.ttf]])
		LSM:Register("font", "Caith",					            [[Interface\Addons\sqwNameplates\media\font\caith.ttf]])
		LSM:Register("font", "Roth",					            [[Interface\Addons\sqwNameplates\media\font\roth.ttf]])
		LSM:Register("font", "Tusqw",					            [[Interface\Addons\sqwNameplates\media\font\tusqw.ttf]])
		LSM:Register("font", "LUI",					                [[Interface\Addons\sqwNameplates\media\font\lui.ttf]])
		LSM:Register("font", "Expressway",					        [[Interface\Addons\sqwNameplates\media\font\expressway.ttf]])

		LSM:Register("statusbar", "Doc",			                [[Interface\Addons\sqwNameplates\media\statusbar\statusbar]])
		LSM:Register("statusbar", "Caith",					        [[Interface\Addons\sqwNameplates\media\statusbar\caith]])
		LSM:Register("statusbar", "Roth",					        [[Interface\Addons\sqwNameplates\media\statusbar\roth]])
		LSM:Register("statusbar", "Tusqw",					        [[Interface\Addons\sqwNameplates\media\statusbar\tusqw]])
		LSM:Register("statusbar", "LUI",					        [[Interface\Addons\sqwNameplates\media\statusbar\lui]])
		
		LSM:Register("border", "Pixel",			                    [[Interface\Addons\sqwNameplates\media\border\fer12]])
		LSM:Register("border", "Caith",					            [[Interface\Addons\sqwNameplates\media\border\caith]])
		LSM:Register("border", "Roth",					            [[Interface\Addons\sqwNameplates\media\border\roth]])
		LSM:Register("border", "Tusqw",					            [[Interface\Addons\sqwNameplates\media\border\tusqw]])
		LSM:Register("border", "LUI",					            [[Interface\Addons\sqwNameplates\media\border\lui]])
		
	end    
		
	--ON ENABLE
	function sqwNameplates:OnEnable()
		db = sqwNameplates.db.profile
		realm = sqwNameplates.db.realm
		
		-- Convert pre-4.0 d
	--[[	if not db.dConverted or db.dConverted<1 then
			processOldData()
		end
		if realm.guildList then realm.guildList = nil end -- Delete the old 3.0 guild list.]]
		
		--REGISTER EVENTS
		self:RegisterEvent("CVAR_UPDATE")
		self:RegisterEvent("PLAYER_LOGIN")
		
		--OTHER FILES
		self:initializeUpdater()
		
		-- CVars
		self:setVisibility()
		SetCVar("ShowClassColorInNameplate", 0)--pvp 1=class color 0=red
		SetCVar("showVKeyCastbar", 1)
		
		
	
	--[[KEY BINDINGS
		local bindingFrame = CreateFrame("Frame")
		t = GetBindingKey("NAMEPLATES")
		if t then SetOverrideBinding(bindingFrame, false, t, "NAMEPLATES_OVERRIDE") end
		t = GetBindingKey("FRIENDNAMEPLATES")
		if t then SetOverrideBinding(bindingFrame, false, t, "FRIENDNAMEPLATES_OVERRIDE") end
		t = GetBindingKey("ALLNAMEPLATES")
		if t then SetOverrideBinding(bindingFrame, false, t, "ALLNAMEPLATES_OVERRIDE") end]]
		
		--CHOOSE PRESET
		if not db.presetChosen then
			sqwNameplates.LoadPreset()
		end
		
		end
	--ON DISABLE
	function sqwNameplates:OnDisable()
		
	end

	--CVAR_UPDATE
	function sqwNameplates:CVAR_UPDATE(event, cvar, value)
		if cvar=="UNIT_NAMEPLATES_SHOW_FRIENDS" then
			if tonumber(value)~=1 then
				SetCVar("nameplateShowFriends", 0)
			else
				SetCVar("nameplateShowFriends", 1)
			end
		elseif cvar=="UNIT_NAMEPLATES_SHOW_FRIENDLY_PETS" then
			if tonumber(value)~=1 then
				SetCVar("nameplateShowFriendlyPets", 0)
			else
				SetCVar("nameplateShowFriendlyPets", 1)
			end
		elseif cvar=="UNIT_NAMEPLATES_SHOW_FRIENDLY_GUARDIANS" then
			if tonumber(value)~=1 then
				SetCVar("nameplateShowFriendlyGuardians", 0)
			else
				SetCVar("nameplateShowFriendlyGuardians", 1)
			end
		elseif cvar=="UNIT_NAMEPLATES_SHOW_FRIENDLY_TOTEMS" then
			if tonumber(value)~=1 then
				SetCVar("nameplateShowFriendlyTotems", 0)
			else
				SetCVar("nameplateShowFriendlyTotems", 1)
			end
		elseif cvar=="UNIT_NAMEPLATES_SHOW_ENEMIES" then
			if tonumber(value)~=1 then
				SetCVar("nameplateShowEnemies", 0)
			else
				SetCVar("nameplateShowEnemies", 1)
			end
		elseif cvar=="UNIT_NAMEPLATES_SHOW_ENEMY_PETS" then
			if tonumber(value)~=1 then
				SetCVar("nameplateShowEnemyPets", 0)
			else
				SetCVar("nameplateShowEnemyPets", 1)
			end
		elseif cvar=="UNIT_NAMEPLATES_SHOW_ENEMY_GUARDIANS" then
			if tonumber(value)~=1 then
				SetCVar("nameplateShowEnemyGuardians", 0)
			else
				SetCVar("nameplateShowEnemyGuardians", 1)
			end
		elseif cvar=="UNIT_NAMEPLATES_SHOW_ENEMY_TOTEMS" then
			if tonumber(value)~=1 then
				SetCVar("nameplateShowEnemyTotems", 0)
			else
				SetCVar("nameplateShowEnemyTotems", 1)
			end
		elseif cvar=="UNIT_NAMEPLATES_ALLOW_OVERLAP" then
			if tonumber(value)~=1 then
				SetNamePlateMotionType(1)
			else
				SetNamePlateMotionType(3) -- 1=overlapping, 2=stacking, 3=spreading
			end
			
		end
	end
	--PLAYER_LOGIN
	function sqwNameplates:PLAYER_LOGIN()
	end

	--CPU TIME
	function sqwNameplates:cpu()
		t = UIParent:CreateFontString(nil, "OVERLAY", "GameFontNormal")
		t:SetWidth(300)
		t:SetHeight(30)
		t:SetPoint("TOP", UIParent, "TOP", -200, -20)
		local display = t
		
		t = UIParent:CreateFontString(nil, "OVERLAY", "GameFontNormal")
		t:SetWidth(300)
		t:SetHeight(30)
		t:SetPoint("TOP", display, "BOTTOM", 0, 0)
		local display2 = t
		
		local function round(num, idp) --number, decimal places
			local mult = 10^(idp or 0)
			return math.floor(num * mult + 0.5) / mult
		end
		
		local lastCpu = 0
		local maxCpu = 0
		
		local frame = CreateFrame("Frame")
		local lastUpdate = 0
		local lastUpdate2 = 0
		local function onUpdate(self, elapsed)
			lastUpdate = lastUpdate + elapsed
			lastUpdate2 = lastUpdate2 + elapsed
			
			if lastUpdate>1 then
				UpdateAddOnCPUUsage()
				
				local cpuSelf = 0
				local total = 0
				for i=1,GetNumAddOns() do
					local name = GetAddOnInfo(i)
					
					local cpu = GetAddOnCPUUsage(name)
					
					if name=="sqwNameplates" then
						cpuSelf = cpu
					end
					
					total = total+cpu
				end
				
				--display:SetText(round(cpuSelf/total*100, 1))
				display:SetText("sqwNameplates CPU/s: "..round((cpuSelf-lastCpu), 2))
				lastCpu = cpuSelf
				maxCpu = max(maxCpu, cpuSelf)
				
				lastUpdate = 0
			end
			
			if lastUpdate2>10 then
				--display2:SetText("sqwNameplates CPU/10s: "..round(maxCpu, 2))
				maxCpu = 0
				
				lastUpdate2 = 0
			end
		end
		
		frame:HookScript("OnUpdate", onUpdate) -- was HookScript
	end

	--TEST PLATES
	function sqwNameplates:test()
		local frames = {}
		
		for i=1,20 do
			local frame = CreateFrame("Frame")
			frame:SetWidth(db.fontsizeName*2)
			frame:SetHeight(db.fontsizeName*2)
			frame:SetPoint("CENTER", UIParent)
			frame:SetAlpha(1)
			
			t = frame:CreateTexture(nil, "OVERLAY")
			t:SetWidth(db.fontsizeName*2)
			t:SetHeight(db.fontsizeName*2)
			t:SetTexCoord(0.1,0.9,0.1,0.9)
			t:SetPoint("CENTER", frame)
			t:SetTexture("Interface\\Icons\\Inv_misc_questionmark")
			
			t = frame:CreateFontString(nil, "OVERLAY", "GameFontNormal")
			t:SetWidth(db.fontsizeName*2)
			t:SetHeight(db.fontsizeName*2)
			t:SetPoint("CENTER", frame)
			t:SetText("A")
			frame.text = t
			
			tinsert(frames, frame)
		end
		
		
		local t = {}
		local c = 1
		while c>#t and c<20000 do
			t[c] = true
			c=c+1
			p(c)
		end
	end