﻿local L = LibStub("AceLocale-3.0"):GetLocale("sqwNameplates")
local LSM = LibStub("LibSharedMedia-3.0")
local db
local t,t2 = nil

--[[ Print ]]
local function p(text)
	ChatFrame3:AddMessage(tostring(text))
end

local _, playerClass = UnitClass("player")

sqwNameplates.version = 1
sqwNameplates.defaults = { 
    profile = {
        version = -1,
       
        import = 0,
        debugMode = false,
        
        -- Options
		targetNHL = false,
		targetNHL2 = false,
		targetIcon = false,
        socialIcon = true,
        classIcon = false,
        roleIcon = false,
        unknownIcon = true,
        guildName = true,
        lfgIcon = true,
        whisperIcon = true,
        tot = true,
		showLevel = true,
		--npHLTexA = true,
		--npHLTexB = false,
		
        width = 60,
        height = 12,
        widthCast = 60,
        heightCast = 12,
        scale = 1,
        scaleBuffs = 1,
        
        combatLogFix = true,
        combatLogFixPrint = false,
        
        fontsize = 13,
        fontsizeHealth = 18,
        fontsizeName = 10,
        fontsizeGuild = 10,
        fontsizeBuffs = 8,
        fontsizeCast = 10,
        
        outline = "NONE",
        font = "Expressway",
        fonti = "Segoe UI Italic",
        fontb = "Segoe UI Bold",
        
        tex = "Doc",
        bg = "Interface\\Addons\\sqwNameplates\\media\\bg",
        border = "Pixel",
        borderIcon = "Interface\\Addons\\sqwNameplates\\media\\borderGradientIcon",
        borderSize = 2,
        

		--fontColor = {r=1,g=1,b=1,a=1},
		fontColor = {r=0.75,g=0.75,b=0.75,a=1},
        customColor = {r=0.3,g=0.3,b=0.3,a=1},
		HBNumberColorCustom = {r=1,g=1,b=1,a=1},
        bgColor = {r=0,g=0,b=0,a=0.5},
        borderColor = {r=0.4,g=0.4,b=0.4,a=1},
        colorThreatVerySafe = {r=0.45,g=0.45,b=0.45,a=1},
        colorThreatSafe = {r=0.875,g=0.875,b=0,a=1},
        colorThreatUnsafe = {r=0.875,g=0.875/2,b=0,a=1},
        colorThreatAlert = {r=0.875,g=0,b=0,a=1},
        colorThreatTanked = {r=0,g=0.875/2,b=0.875,a=1},
        castColor = { r=255/255, g=201/255, b=14/255, a=1 },
        
        
        threatEnabled = true,
        
        --showHpAbsolutPercent = false,
		showHpAbsolut = false,
        showHpPercent = true,
        showHpBar = false,
		healthBarNumberColorCustom = false,
        healthBarColorCustom = false,
        healthBarColorPvP = false,
        healthBarColorClass = true,
        healthBarFriendPve = false,
        healthBarEnemyPve = true,
        healthBarFriendPveCombat = false,
        healthBarEnemyPveCombat = true,
        healthBarFriendPvp = false,
        healthBarEnemyPvp = true,
        
        castBarFriendPve = false,
        castBarEnemyPve = true,
        castBarFriendPveCombat = false,
        castBarEnemyPveCombat = true,
        castBarFriendPvp = false,
        castBarEnemyPvp = true,
        castBarNonTargets = true,
        
        buffsNumber = 6,
        buffsFriendPve = false,
        buffsEnemyPve = true,
        buffsFriendPveCombat = false,
        buffsEnemyPveCombat = true,
        buffsFriendPvp = false,
        buffsEnemyPvp = true,
        
        allowOverlap = true,
        
        visPveFriendUnit = true,
        visPveFriendPet = false,
        visPveFriendGuardian = false,
        visPveFriendTotem = false,
        visPveEnemyUnit = true,
        visPveEnemyPet = false,
        visPveEnemyGuardian = true,
        visPveEnemyTotem = true,
        
        visPvecombatFriendUnit = false,
        visPvecombatFriendPet = false,
        visPvecombatFriendGuardian = false,
        visPvecombatFriendTotem = false,
        visPvecombatEnemyUnit = true,
        visPvecombatEnemyPet = false,
        visPvecombatEnemyGuardian = true,
        visPvecombatEnemyTotem = true,
        
        visPvpFriendUnit = true,
        visPvpFriendPet = false,
        visPvpFriendGuardian = false,
        visPvpFriendTotem = false,
        visPvpEnemyUnit = true,
        visPvpEnemyPet = false,
        visPvpEnemyGuardian = false,
        visPvpEnemyTotem = true,
        
        buffFilter = {
            buffs = {
                my = {},
                any = {},
                never = {},
                allMy = false,
                allAny = false,
            },
            debuffs = {
                my = {},
                any = {},
                never = {},
                allMy = false,
                allAny = false,
            },
            filterLow = true,
            emphasize = false,
        },
        
        
        -- General Options
        heightCast = 5,
        heightThreat = 3,
        sizeBuffs = 14,
        sizeTotem = 16,
        
        spacing = 2,
        spacingFixed = 2,
        
        fontoffset = 0,
        
        texComboPoint1 = "Interface\\Addons\\sqwNameplates\\media\\combo1",
        texComboPoint2 = "Interface\\Addons\\sqwNameplates\\media\\combo2",
        texComboPoint3 = "Interface\\Addons\\sqwNameplates\\media\\combo3",
        texComboPoint4 = "Interface\\Addons\\sqwNameplates\\media\\combo4",
        texComboPoint5 = "Interface\\Addons\\sqwNameplates\\media\\combo5",
        
        alpha = 0.40, -- default alpha setting
		MoAlpha = 0.75, -- default Mouseover alpha setting
        
        showNameplates = true,
        UPDATE_FREQUENCY = 0.1,
        showNameplateName = true,
        showNameplatePvpName = true,
        
        nameplateHider = {},
        
        -- Bossplates
        professorPutricide = true,
        
        healingSpells = {

--[[

            strlower(GetSpellInfo(31739) or "nil"),		--Heal
            strlower(GetSpellInfo(2147) or "nil"),		--Mending
            strlower(GetSpellInfo(50464) or "nil"),		--Nourish
           	strlower(GetSpellInfo(8936) or "nil"),		--Regrowth
            strlower(GetSpellInfo(740) or "nil"),		--Tranquility
            strlower(GetSpellInfo(64843) or "nil"),		--Divine Hymn
			strlower(GetSpellInfo(47540) or "nil"),		--Penance
            strlower(GetSpellInfo(635) or "nil"),		--Holy Light
            strlower(GetSpellInfo(19750) or "nil"),		--Flash of Light
			strlower(GetSpellInfo(115175) or "nil"),	--Soothing mist
			strlower(GetSpellInfo(116694) or "nil"),	--Surging mist
			strlower(GetSpellInfo(124682) or "nil"),	--Enveloping mist]]
        },
    },
    
    realm = {
        playerList = {},
    },
    
    global = {
        healerList = {},
        casterList = {},
        agressiveList = {},
        npcList = {},
        spellList = {},
        nameplateHider = {},
        nameReplacer = {},
        LFGList = {},
    },
    
}

local db = sqwNameplates.defaults.profile

local agressiveList = {
    ["Initiate's Training Dummy"] = true,
    ["Disciple's Training Dummy"] = true,
    ["Veteran's Training Dummy"] = true,
    ["Ebon Knight's Training Dummy"] = true,
    ["Highlord's Nemesis Trainer"] = true,
    ["Expert's Training Dummy"] = true,
    ["Training Dummy"] = true,
    ["Raider's Training Dummy"] = true,
	["Enemy Tonk"] = true,

}

local nameplateHider = {
    "Dark Rune Commoner",		  
    "Dunkler Runenb\195\188rger", 
    "Onyxian Whelp",
    "Welpe von Onyxia",
    "Forest Swarmer",
    "Fanged Pit Viper",
    "Bissige Grubenotter",
}

local nameReplacer = {
    ["Val'kyr Shadowguard"] = "Valk",
    ["Heroic Training Dummy"] = "Boss",
}

local LFGList = {
    "lfm",
}

local myBuffs = {
    ["WARRIOR"] = {
        
    },
    ["MAGE"] = {
        
    },
    ["ROGUE"] = {
        
    },
    ["DRUID"] = {
        
    },
    ["HUNTER"] = {
        
    },
    ["SHAMAN"] = {
        
    },
    ["PRIEST"] = {
        
    },
    ["WARLOCK"] = {
        
    },
    ["PALADIN"] = {
        
    },
    ["DEATHKNIGHT"] = {
        
    },

	["MONK"] = {

    },
}

local anyBuffs = {
    {642,3,true},		--Divine Shield
    {1022,3,true},		--Hand of Protection
    {45438,3,true},		--Ice Block
    {31224,3,true},		--Cloak of Shadows
    {5277,3,true},		--Evasion
    {781,3,true},		--Disengage
    {22812,3,false},	--Barkskin
    {47585,3,true},		--Dispersion
    {46924,3,true},		--Bladestorm
	{69558,3,true},		--Unstable Ooze
    {70768,3,true},		--Shroud of the Occult
    {70842,3,true},		--Mana Barrier
    {71730,3,true},		--Lay Waste
	{115203,3,true},	--Fortifying Brew
	{115176,3,true},	--Zen Meditation
	{102141,3,true},	--Transcendence
	{102342,3,true},	--Ironbark
	{61573,1,true},		--Banner of the Alliance
    
}

local myDebuffs = {
    ["WARRIOR"] = {
        {1715,3,false},		--Hamstring
    },
    ["MAGE"] = {
        {31589,3,false},	--Slow
        {44457,3,false},	--Living Bomb
    },
    ["ROGUE"] = {
        
    },
    ["DRUID"] = {
        {5570,3,false},		--Insect Swarm
        {8921,3,false},		--Moonfire
    },
    ["HUNTER"] = {
        
    },
    ["SHAMAN"] = {
        
    },
    ["PRIEST"] = {
        {589,3,false},		--Shadow Word: Pain
        {34914,3,false},	--Vampiric Touch
        {2944,3,false},		--Devouring Plague
        {48045,3,false},	--Mind Sear
    },
    ["WARLOCK"] = {
        {172,3,false},		--Corruption
        {980,3,false},		--Bane of Agony
        {603,3,false},		--Bane of Doom
        {1714,3,false},		--Curse of Tongues
        {702,3,false},		--Curse of Weakness
        {18223,3,false},	--Curse of Exhaustion
        {348,3,false},		--Immolate
        {48181,3,false},	--Haunt
        {27243,3,false},	--Seed of Corruption
    },
    ["PALADIN"] = {
        
    },
    ["DEATHKNIGHT"] = {
        {59921,3,false},	--Frost Fever
        {59879,3,false},	--Blood Plague
    },
    ["MONK"] = {
        {117952,3,false},	--Crackling Jade Lightning
	},
}

local anyDebuffs = {
    {19386,3,true},			--Wyvern Sting
    {60192,3,true},			--Freezing Trap
    {118,3,true},			--Polymorph
    {6770,3,true},			--Sap
    {51514,3,true},			--Hex
    {710,3,true},			--Banish
    {2094,3,true},			--Blind
	{115078,3,true},		--Paralysis
    {73912,3,true},			--Necrotic Plague
}

for i=1,#nameplateHider do
    sqwNameplates.defaults.global.nameplateHider[nameplateHider[i]] = true
end

for i,v in pairs(nameReplacer) do
    sqwNameplates.defaults.global.nameReplacer[i] = v
end

for i=1,#LFGList do
    tinsert(sqwNameplates.defaults.global.LFGList, LFGList[i])
end

for i=1,#agressiveList do
    local name = strlower(agressiveList[i])
    
    tinsert(sqwNameplates.defaults.global.agressiveList, name)
end

local list = anyBuffs
for i=1,#list do
    local name = GetSpellInfo(list[i][1])
    
    if name then db.buffFilter.buffs.any[name] = { list[i][2], list[i][3] } end
end

local list = anyDebuffs
for i=1,#list do
    local name = GetSpellInfo(list[i][1])
    
    if name then db.buffFilter.debuffs.any[name] = { list[i][2], list[i][3] } end
end

local list = myBuffs[playerClass]
for i=1,#list do
    local name = GetSpellInfo(list[i][1])
    
    if name then db.buffFilter.buffs.my[name] = { list[i][2], list[i][3] } end
end

local list = myDebuffs[playerClass]
for i=1,#list do
    local name = GetSpellInfo(list[i][1])
    
    if name then db.buffFilter.debuffs.my[name] = { list[i][2], list[i][3] } end
end