﻿	local L = LibStub("AceLocale-3.0"):GetLocale("sqwNameplates")
	local LSM = LibStub("LibSharedMedia-3.0")
	local t, t2 = nil

	--[[ Print ]]
	local function p(text)
		ChatFrame3:AddMessage(tostring(text))
	end

	local db, global
	local resources = sqwNameplates.resources
	local optionFrames = {}
	local greyTone = 0 
	local optionWidth = 175
	local optionHeight = 25
	local fontSizeTitle = 14
	local fontSizeOption = 11
	local borderSize = 10
	sqwNameplates.configMode = false
	local presetFrame

	local font, fontb, fonti
	local locale = GetLocale()
	if locale=="enUS" or locale=="deDE" or locale=="frFR" then
		font = "Interface\\Addons\\sqwNameplates\\media\\font\\segoe_ui.ttf"
		fontb = "Interface\\Addons\\sqwNameplates\\media\\font\\segoe_ui_bold.ttf"
		fonti = "Interface\\Addons\\sqwNameplates\\media\\font\\segoe_ui_italic.ttf"
	elseif locale=="koKR" then
		font = "Fonts\\2002.TTF"
		fontb = "Fonts\\2002B.TTF"
		fonti = "Fonts\\2002.TTF"
	else
		font = "Fonts\\FRIZQT__.TTF"
		fontb = "Fonts\\FRIZQT__.TTF"
		fonti = "Fonts\\FRIZQT__.TTF"
	end

	local function presetDone()
		db.presetChosen = sqwNameplates.version
	end

	local function filterAddOnClick(self) -- When clicking on the filter add button
		local name = db.buffFilter.filterName
		local my = db.buffFilter.filterOnlyMy
		local buff = db.buffFilter.filterBuff
		local debuff = db.buffFilter.filterDebuff
		local never = db.buffFilter.filterNeverShow
		local high = db.buffFilter.filterHigh
		local medium = db.buffFilter.filterMedium
		local low = db.buffFilter.filterLow
		local priority
		local list
		
		if not name or name=="" then return end
		
		if buff then
			if my then
				list = db.buffFilter.buffs.my
			elseif never then
				list = db.buffFilter.buffs.never
			else
				list = db.buffFilter.buffs.any
			end
		elseif debuff then
			if my then
				list = db.buffFilter.debuffs.my
			elseif never then
				list = db.buffFilter.debuffs.never
			else
				list = db.buffFilter.debuffs.any
			end
		end
		
		if high then
			priority = 3
		elseif medium then
			priority = 2
		else
			priority = 1
		end
		
		list[name] = { priority, db.buffFilter.emphasize }
	end

	local function lPBlizzard() -- Defaults to load for preset "Blizzard"
		db.font = "Friz Quadrata TT"
		db.fontb = "Friz Quadrata TT"
		db.fonti = "Friz Quadrata TT"
		db.tex = "Blizzard"
		db.border = "Blizzard Tooltip"
		db.borderColor = {r=0.4,g=0.4,b=0.4,a=1}
		if presetFrame.healthbar then
			db.showHpBar = true
			db.fontsizeHealth = 11
		end
		
		-- Follow up
		sqwNameplates:refreshNameplateLayouts()
		presetFrame:Hide()
	end

	local function lPDoc() -- Defaults to load for preset "Doc"
		db.font = "Segoe UI"
		db.fontb = "Segoe UI Bold"
		db.fonti = "Segoe UI Italic"
		db.tex = "Doc"
		db.border = "Pixel"
		db.borderColor = {r=0,g=0,b=0,a=1}
		if presetFrame.healthbar then
			db.showHpBar = true
			db.fontsizeHealth = 11
		end
		
		-- Follow up
		sqwNameplates:refreshNameplateLayouts()
		presetFrame:Hide()
	end

	local function lPCaith() -- Defaults to load for preset "Caith"
		db.font = "Caith"
		db.fontb = "Caith"
		db.fonti = "Caith"
		db.tex = "Caith"
		db.border = "Caith"
		db.borderColor = {r=1,g=1,b=1,a=1}
		if presetFrame.healthbar then
			db.showHpBar = true
			db.fontsizeHealth = 11
		end
		
		-- Follow up
		sqwNameplates:refreshNameplateLayouts()
		presetFrame:Hide()
	end

	local function lPRoth() -- Defaults to load for preset "Roth"
		db.font = "Roth"
		db.fontb = "Roth"
		db.fonti = "Roth"
		db.tex = "Roth"
		db.border = "Roth"
		db.borderColor = {r=1,g=1,b=1,a=1}
		if presetFrame.healthbar then
			db.showHpBar = true
			db.fontsizeHealth = 11
		end
		
		-- Follow up
		sqwNameplates:refreshNameplateLayouts()
		presetFrame:Hide()
	end

	local function lPLui() -- Defaults to load for preset "LUI"
		db.font = "LUI"
		db.fontb = "LUI"
		db.fonti = "LUI"
		db.tex = "LUI"
		db.border = "LUI"
		db.borderColor = {r=0,g=0,b=0,a=1}
		if presetFrame.healthbar then
			db.showHpBar = true
			db.fontsizeHealth = 11
		end
		
		-- Follow up
		sqwNameplates:refreshNameplateLayouts()
		presetFrame:Hide()
	end

	local function lPTukui() -- Defaults to load for preset "TukUI"
		db.font = "TukUI"
		db.fontb = "TukUI"
		db.fonti = "TukUI"
		db.tex = "TukUI"
		db.border = "TukUI"
		db.borderColor = {r=0,g=0,b=0,a=1}
		if presetFrame.healthbar then
			db.showHpBar = true
			db.fontsizeHealth = 11
		end
		
		-- Follow up
		sqwNameplates:refreshNameplateLayouts()
		presetFrame:Hide()
	end

	local function lPExpress() -- Defaults to load for preset "TukUI"
		db.font = "Expressway"
		db.fontb = "Expressway"
		db.fonti = "Segoe UI Italic"
		db.tex = "TukUI"
		db.border = "TukUI"
		db.borderColor = {r=0,g=0,b=0,a=1}
		if presetFrame.healthbar then
			db.showHpBar = true
			db.fontsizeHealth = 18
		end
		
		-- Follow up
		sqwNameplates:refreshNameplateLayouts()
		presetFrame:Hide()
	end


	local function spawnPresetFrame()
		local width = 256
		local height = 64
		
		presetFrame = CreateFrame("Frame", "sqwNameplates_preset", UIParent)
		presetFrame:SetAlpha(1)
		presetFrame:SetPoint("TOPLEFT", UIParent)
		presetFrame:SetPoint("BOTTOMRIGHT", UIParent)
		presetFrame:EnableMouse(true)
		presetFrame:SetFrameStrata("FULLSCREEN_DIALOG") 
		--tinsert(UISpecialFrames, presetFrame:GetName())
		presetFrame:Hide()
		
		t = presetFrame:CreateTexture(nil, "BACKGROUND")
		t:SetTexture(db.bg)
		t:SetAllPoints(presetFrame)
		t:SetVertexColor(0, 0, 0, 0.75)
		
		t = CreateFrame("Button", nil, presetFrame, "OptionsButtonTemplate") -- Close button
		t:SetWidth(80)
		t:SetHeight(22)
		t:SetPoint("TOPRIGHT", presetFrame, "TOPRIGHT", -20, -20)
		t:SetText(CLOSE)
		t:HookScript("OnClick", function(self)
			presetFrame:Hide()
			presetDone()
		end)
		
		  
		-- Doc
		local doc = CreateFrame("Button", nil, presetFrame)
		t = doc
		t:SetWidth(width*2+10)
		t:SetHeight(height*2+10)
		t:SetPoint("TOP", presetFrame, "TOP", 0, -100)
		t:HookScript("OnClick", function(self)
			lPDoc()
			presetDone()
		end)
		t:HookScript("OnEnter", function(self)
			doc.highlight:Show()
		end)
		t:HookScript("OnLeave", function() doc.highlight:Hide() end)
		
		t = doc:CreateTexture(nil, "BACKGROUND")
		t:SetTexture("Interface\\Addons\\sqwNameplates\\media\\preset\\doc")
		t:SetAllPoints(doc)
		t:SetVertexColor(1, 1, 1, 1)
		
		t = doc:CreateTexture(nil, "OVERLAY")
		t:SetTexture("Interface\\Addons\\sqwNameplates\\media\\preset\\doch")
		t:SetAllPoints(doc)
		t:SetVertexColor(1, 1, 1, 1)
		t:Hide()
		doc.highlight = t
		
		-- Blizzard
		local blizzard = CreateFrame("Button", nil, presetFrame)
		t = blizzard
		t:SetWidth(width)
		t:SetHeight(height)
		t:SetPoint("TOPLEFT", doc, "BOTTOMLEFT", 0, -10)
		t:HookScript("OnClick", function(self)
			lPBlizzard()
			presetDone()
		end)
		t:HookScript("OnEnter", function(self)
			blizzard.highlight:Show()
		end)
		t:HookScript("OnLeave", function() blizzard.highlight:Hide() end)
		
		t = blizzard:CreateTexture(nil, "BACKGROUND")
		t:SetTexture("Interface\\Addons\\sqwNameplates\\media\\preset\\blizzard")
		t:SetAllPoints(blizzard)
		t:SetVertexColor(1, 1, 1, 1)
		
		t = blizzard:CreateTexture(nil, "OVERLAY")
		t:SetTexture("Interface\\Addons\\sqwNameplates\\media\\preset\\blizzardh")
		t:SetAllPoints(blizzard)
		t:SetVertexColor(1, 1, 1, 1)
		t:Hide()
		blizzard.highlight = t
		
		-- Caith
		local caith = CreateFrame("Button", nil, presetFrame)
		t = caith
		t:SetWidth(width)
		t:SetHeight(height)
		t:SetPoint("TOPRIGHT", doc, "BOTTOMRIGHT", 0, -10)
		t:HookScript("OnClick", function(self)
			lPCaith()
			presetDone()
		end)
		t:HookScript("OnEnter", function(self)
			caith.highlight:Show()
		end)
		t:HookScript("OnLeave", function() caith.highlight:Hide() end)
		
		t = caith:CreateTexture(nil, "BACKGROUND")
		t:SetTexture("Interface\\Addons\\sqwNameplates\\media\\preset\\caith")
		t:SetAllPoints(caith)
		t:SetVertexColor(1, 1, 1, 1)
		
		t = caith:CreateTexture(nil, "OVERLAY")
		t:SetTexture("Interface\\Addons\\sqwNameplates\\media\\preset\\caithh")
		t:SetAllPoints(caith)
		t:SetVertexColor(1, 1, 1, 1)
		t:Hide()
		caith.highlight = t
		
		-- Roth
		local roth = CreateFrame("Button", nil, presetFrame)
		t = roth
		t:SetWidth(width)
		t:SetHeight(height)
		t:SetPoint("TOPLEFT", blizzard, "BOTTOMLEFT", 0, -10)
		t:HookScript("OnClick", function(self)
			lPRoth()
			db.presetChosen = 1
		end)
		t:HookScript("OnEnter", function(self)
			roth.highlight:Show()
		end)
		t:HookScript("OnLeave", function() roth.highlight:Hide() end)
		
		t = roth:CreateTexture(nil, "BACKGROUND")
		t:SetTexture("Interface\\Addons\\sqwNameplates\\media\\preset\\roth")
		t:SetAllPoints(roth)
		t:SetVertexColor(1, 1, 1, 1)
		
		t = roth:CreateTexture(nil, "OVERLAY")
		t:SetTexture("Interface\\Addons\\sqwNameplates\\media\\preset\\rothh")
		t:SetAllPoints(roth)
		t:SetVertexColor(1, 1, 1, 1)
		t:Hide()
		roth.highlight = t
		
		-- LUI
		local lui = CreateFrame("Button", nil, presetFrame)
		t = lui
		t:SetWidth(width)
		t:SetHeight(height)
		t:SetPoint("TOPRIGHT", caith, "BOTTOMRIGHT", 0, -10)
		t:HookScript("OnClick", function(self)
			lPLui()
			presetDone()
		end)
		t:HookScript("OnEnter", function(self)
			lui.highlight:Show()
		end)
		t:HookScript("OnLeave", function() lui.highlight:Hide() end)
		
		t = lui:CreateTexture(nil, "BACKGROUND")
		t:SetTexture("Interface\\Addons\\sqwNameplates\\media\\preset\\lui")
		t:SetAllPoints(lui)
		t:SetVertexColor(1, 1, 1, 1)
		
		t = lui:CreateTexture(nil, "OVERLAY")
		t:SetTexture("Interface\\Addons\\sqwNameplates\\media\\preset\\luih")
		t:SetAllPoints(lui)
		t:SetVertexColor(1, 1, 1, 1)
		t:Hide()
		lui.highlight = t
		
		-- Tuk UI
		local tukui = CreateFrame("Button", nil, presetFrame)
		t = tukui
		t:SetWidth(width)
		t:SetHeight(height)
		t:SetPoint("TOPLEFT", roth, "BOTTOMLEFT", 0, -10)
		t:HookScript("OnClick", function(self)
			lPTukui()
			presetDone()
		end)
		t:HookScript("OnEnter", function(self)
			tukui.highlight:Show()
		end)
		t:HookScript("OnLeave", function() tukui.highlight:Hide() end)
		
		t = tukui:CreateTexture(nil, "BACKGROUND")
		t:SetTexture("Interface\\Addons\\sqwNameplates\\media\\preset\\tukui")
		t:SetAllPoints(tukui)
		t:SetVertexColor(1, 1, 1, 1)
		
		t = tukui:CreateTexture(nil, "OVERLAY")
		t:SetTexture("Interface\\Addons\\sqwNameplates\\media\\preset\\tukuih")
		t:SetAllPoints(tukui)
		t:SetVertexColor(1, 1, 1, 1)
		t:Hide()
		tukui.highlight = t
		
		-- Express UI
		local Express = CreateFrame("Button", nil, presetFrame)
		t = Express
		t:SetWidth(width)
		t:SetHeight(height)
		t:SetPoint("TOPLEFT", lui, "BOTTOMLEFT", 0, -10)
		t:HookScript("OnClick", function(self)
			lPExpress()
			presetDone()
		end)
		t:HookScript("OnEnter", function(self)
			Express.highlight:Show()
		end)
		t:HookScript("OnLeave", function() Express.highlight:Hide() end)
		
		t = Express:CreateTexture(nil, "BACKGROUND")
		t:SetTexture("Interface\\Addons\\sqwNameplates\\media\\preset\\Express")
		t:SetAllPoints(Express)
		t:SetVertexColor(1, 1, 1, 1)
		
		t = Express:CreateTexture(nil, "OVERLAY")
		t:SetTexture("Interface\\Addons\\sqwNameplates\\media\\preset\\Expressh")
		t:SetAllPoints(Express)
		t:SetVertexColor(1, 1, 1, 1)
		t:Hide()
		Express.highlight = t
		
		-- Healthbar
		t = CreateFrame("CheckButton", nil, presetFrame, "OptionsCheckButtonTemplate")
		t:SetWidth(64)
		t:SetHeight(64)
		t:SetHitRectInsets(0, -width+64, 0, 0)
		t:SetPoint("TOPLEFT", presetFrame, "TOP", -width/3, -500)
		local function onClick(self, button, down)
			local checked = self:GetChecked()
			
			presetFrame.healthbar = checked
		end
		t:HookScript("OnClick", onClick)
		t:HookScript("OnShow", function(self)
			self:SetChecked(false)
		end)
		t:HookScript("OnEnter", function(self)
			GameTooltip:SetOwner(self, "ANCHOR_LEFT")
			GameTooltip:AddLine("")
			GameTooltip:Show()
		end)
		t:HookScript("OnLeave", function() GameTooltip:Hide() end)
		presetFrame.button = t
		local button = t
		
		t = presetFrame:CreateFontString(nil, "OVERLAY", "GameFontNormal")
		t:SetWidth(width*2-64)
		t:SetHeight(64)
		t:SetPoint("LEFT", button, "RIGHT", 0, 0)
		t:SetFont(font, fontSizeTitle*2)
		t:SetJustifyH("LEFT")
		t:SetJustifyV("CENTER")
		t:SetShadowColor(0,0,0,1)
		t:SetShadowOffset(1,-1)
		t:SetTextColor(db.fontColor.r,db.fontColor.g,db.fontColor.b,db.fontColor.a)
		t:SetText(L["I want a healthbar"])
	end

	function sqwNameplates:LoadPreset() -- Load preset
		InterfaceOptionsFrame:Hide()
		presetFrame:Show()
	end

	local info = {}
	local function texDropDownMenu(self, level) -- Statusbar
		if not level then return end
		wipe(info)
		
		local list = LSM:List("statusbar")
		
		if level==1 then
			info.text = CLOSE
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)
			
			for i=1,ceil(#list/10) do
				-- Create the title of the menu
				info.text = i
				info.notCheckable = 1
				info.hasArrow = 1
				info.value = i
				UIDropDownMenu_AddButton(info, level)
			end
		elseif level==2 then
			for i=(UIDROPDOWNMENU_MENU_VALUE-1)*10+1,min(UIDROPDOWNMENU_MENU_VALUE*10, #list) do
				-- Create the title of the menu
				info.text = list[i]
				info.notCheckable = 1
				info.func = function()
					db.tex = list[i]
					
					-- Follow up
					sqwNameplates:refreshNameplateLayouts()
				end
				UIDropDownMenu_AddButton(info, level)
			end
		end
	end

	local function borderDropDownMenu(self, level) -- Statusbar
		if not level then return end
		wipe(info)
		
		local list = LSM:List("border")
		
		if level==1 then
			info.text = CLOSE
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)
			
			for i=1,ceil(#list/10) do
				-- Create the title of the menu
				info.text = i
				info.notCheckable = 1
				info.hasArrow = 1
				info.value = i
				UIDropDownMenu_AddButton(info, level)
			end
		elseif level==2 then
			for i=(UIDROPDOWNMENU_MENU_VALUE-1)*10+1,min(UIDROPDOWNMENU_MENU_VALUE*10, #list) do
				-- Create the title of the menu
				info.text = list[i]
				info.notCheckable = 1
				info.func = function()
					db.border = list[i]
					
					-- Follow up
					sqwNameplates:refreshNameplateLayouts()
				end
				UIDropDownMenu_AddButton(info, level)
			end
		end
	end

	local function fontDropDownMenu(self, level) -- Font
		if not level then return end
		wipe(info)
		
		local list = LSM:List("font")
		
		if level==1 then
			info.text = CLOSE
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)
			
			for i=1,ceil(#list/10) do
				-- Create the title of the menu
				info.text = i
				info.notCheckable = 1
				info.hasArrow = 1
				info.value = i
				UIDropDownMenu_AddButton(info, level)
			end
		elseif level==2 then
			for i=(UIDROPDOWNMENU_MENU_VALUE-1)*10+1,min(UIDROPDOWNMENU_MENU_VALUE*10, #list) do
				-- Create the title of the menu
				info.text = list[i]
				info.notCheckable = 1
				info.func = function()
					db.font = list[i]
					
					-- Follow up
					sqwNameplates:refreshNameplateLayouts()
				end
				UIDropDownMenu_AddButton(info, level)
			end
		end
	end

	local function fontbDropDownMenu(self, level) -- Font Bold
		if not level then return end
		wipe(info)
		
		local list = LSM:List("font")
		
		if level==1 then
			info.text = CLOSE
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)
			
			for i=1,ceil(#list/10) do
				-- Create the title of the menu
				info.text = i
				info.notCheckable = 1
				info.hasArrow = 1
				info.value = i
				UIDropDownMenu_AddButton(info, level)
			end
		elseif level==2 then
			for i=(UIDROPDOWNMENU_MENU_VALUE-1)*10+1,min(UIDROPDOWNMENU_MENU_VALUE*10, #list) do
				-- Create the title of the menu
				info.text = list[i]
				info.notCheckable = 1
				info.func = function()
					db.fontb = list[i]
					
					-- Follow up
					sqwNameplates:refreshNameplateLayouts()
				end
				UIDropDownMenu_AddButton(info, level)
			end
		end
	end

	local function fontiDropDownMenu(self, level) -- Font Italic
		if not level then return end
		wipe(info)
		
		local list = LSM:List("font")
		
		if level==1 then
			info.text = CLOSE
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)
			
			for i=1,ceil(#list/10) do
				-- Create the title of the menu
				info.text = i
				info.notCheckable = 1
				info.hasArrow = 1
				info.value = i
				UIDropDownMenu_AddButton(info, level)
			end
		elseif level==2 then
			for i=(UIDROPDOWNMENU_MENU_VALUE-1)*10+1,min(UIDROPDOWNMENU_MENU_VALUE*10, #list) do
				-- Create the title of the menu
				info.text = list[i]
				info.notCheckable = 1
				info.func = function()
					db.fonti = list[i]
					
					-- Follow up
					sqwNameplates:refreshNameplateLayouts()
				end
				UIDropDownMenu_AddButton(info, level)
			end
		end
	end

	local function outlineDropDownMenu(self, level) -- Outline
		if not level then return end
		wipe(info)
		
		if level==1 then
			info.text = L["None"]
			info.notCheckable = 1
			--info.fontObject = nil
			info.func = function()
				db.outline = "NONE"
				
				-- Follow up
				sqwNameplates:refreshNameplateLayouts()
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = L["Thin outline"]
			info.notCheckable = 1
			--info.fontObject = nil
			info.func = function()
				db.outline = "OUTLINE"
				
				-- Follow up
				sqwNameplates:refreshNameplateLayouts()
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = L["Thick outline"]
			info.notCheckable = 1
			--info.fontObject = nil
			info.func = function()
				db.outline = "THICKOUTLINE"
				
				-- Follow up
				sqwNameplates:refreshNameplateLayouts()
			end
			UIDropDownMenu_AddButton(info, level)
		end
	end
	-- DELETE BUFFS NOT WORKING??
	local function deleteBuffsDropDownMenu(self, level) -- Delete Buffs
		if not level then return end
		wipe(info)
		
		if level==1 then
			info.text = CLOSE
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "--- "..L["My"]
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)
			for i,v in pairs(db.buffFilter.buffs.my) do
				info.text = "  "..i.." ("..v..")"
				info.notCheckable = 1
				info.arg1 = i
				info.arg2 = v
				info.func = function(self, arg1, arg2)
					db.buffFilter.buffs.my[arg1] = nil
				end
				UIDropDownMenu_AddButton(info, level)
			end
			
			info.text = "--- "..L["Any"]
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)
			for i,v in pairs(db.buffFilter.buffs.any) do
				info.text = "  "..i.." ("..v..")"
				info.notCheckable = 1
				info.arg1 = i
				info.arg2 = v
				info.func = function(self, arg1, arg2)
					db.buffFilter.buffs.any[arg1] = nil
				end
				UIDropDownMenu_AddButton(info, level)
			end
			
			info.text = "--- "..L["Never show"]
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)
			for i,v in pairs(db.buffFilter.buffs.never) do
				info.text = "  "..i.." ("..v..")"
				info.notCheckable = 1
				info.arg1 = i
				info.arg2 = v
				info.func = function(self, arg1, arg2)
					db.buffFilter.buffs.never[arg1] = nil
				end
				UIDropDownMenu_AddButton(info, level)
			end
		end
	end

	local function deleteDebuffsDropDownMenu(self, level) -- Delete Buffs
		if not level then return end
		wipe(info)
		
		if level==1 then
			info.text = CLOSE
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "--- "..L["My"]
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)
			for i,v in pairs(db.buffFilter.debuffs.my) do
				info.text = "  "..i.." ("..v..")"
				info.notCheckable = 1
				info.arg1 = i
				info.arg2 = v
				info.func = function(self, arg1, arg2)
					db.buffFilter.debuffs.my[arg1] = nil
				end
				UIDropDownMenu_AddButton(info, level)
			end
			
			info.text = "--- "..L["Any"]
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)
			for i,v in pairs(db.buffFilter.debuffs.any) do
				info.text = "  "..i.." ("..v..")"
				info.notCheckable = 1
				info.arg1 = i
				info.arg2 = v
				info.func = function(self, arg1, arg2)
					db.buffFilter.debuffs.any[arg1] = nil
				end
				UIDropDownMenu_AddButton(info, level)
			end
			
			info.text = "--- "..L["Never show"]
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)
			for i,v in pairs(db.buffFilter.debuffs.never) do
				info.text = "  "..i.." ("..v..")"
				info.notCheckable = 1
				info.arg1 = i
				info.arg2 = v
				info.func = function(self, arg1, arg2)
					db.buffFilter.debuffs.never[arg1] = nil
				end
				UIDropDownMenu_AddButton(info, level)
			end
		end
	end

	local function deleteHiderDropDownMenu(self, level) -- Delete hider entry
		if not level then return end
		wipe(info)
		
		if level==1 then
			info.text = CLOSE
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)
			
			for i,v in pairs(global.nameplateHider) do
				info.text = i
				info.notCheckable = 1
				info.arg1 = i
				info.arg2 = v
				info.func = function(self, arg1, arg2)
					global.nameplateHider[arg1] = nil
					
					-- Follow up
					sqwNameplates:refreshNameplateLayouts()
				end
				UIDropDownMenu_AddButton(info, level)
			end
		end
	end

	local function deleteReplacerDropDownMenu(self, level) -- Delete replacer entry
		if not level then return end
		wipe(info)
		
		if level==1 then
			info.text = CLOSE
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)
			
			for i,v in pairs(global.nameReplacer) do
				info.text = i..","..v
				info.notCheckable = 1
				info.arg1 = i
				info.arg2 = v
				info.func = function(self, arg1, arg2)
					global.nameReplacer[arg1] = nil
					
					-- Follow up
					sqwNameplates:refreshNameplateLayouts()
				end
				UIDropDownMenu_AddButton(info, level)
			end
		end
	end

	local function deleteLFGDropDownMenu(self, level) -- Delete replacer entry
		if not level then return end
		wipe(info)
		
		if level==1 then
			info.text = CLOSE
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)
			
			for i=1,#global.LFGList do
				info.text = global.LFGList[i]
				info.notCheckable = 1
				info.arg1 = i
				info.func = function(self, arg1)
					global.LFGList[arg1] = nil
					
					-- Follow up
					sqwNameplates:refreshNameplateLayouts()
				end
				UIDropDownMenu_AddButton(info, level)
			end
		end
	end

	local function spawnContainer(self)
		t = CreateFrame("Frame", nil, self)
		t:SetWidth(optionWidth+2*borderSize)
		t:SetHeight(optionHeight*1+2*borderSize)
		--t:SetPoint("TOPLEFT", self, 50, -64)
		t:EnableMouse(true)
		t:SetAlpha(1)
		
		t:HookScript("OnShow", function(self)
			local max = #self.options
			
			if max<1 then
				self:SetWidth(optionWidth+2*borderSize)
				self:SetHeight(optionHeight*1+2*borderSize)
			else
				self:SetWidth(optionWidth+2*borderSize)
				self:SetHeight(optionHeight*max+2*borderSize)
			end
		end)
		local frame = t
		frame.options = {}
		
		t = frame:CreateTexture(nil, "BACKGROUND")
		t:SetTexture(db.bg)
		t:SetAllPoints(frame)
		t:SetVertexColor(greyTone, greyTone, greyTone, 0.40)
		frame.bg = t
		
		return frame
	end

	local function spawnTitle(self, title)
		title = title or "Title NYI"
		
		t = self:CreateFontString(nil, "OVERLAY")
		t:SetWidth(optionWidth)
		t:SetHeight(optionHeight)
		if #self.options>0 then
			t:SetPoint("TOPLEFT", self.options[#self.options], "BOTTOMLEFT", 0, 0)
		else
			t:SetPoint("TOPLEFT", self, "TOPLEFT", borderSize, -borderSize)
		end
		t:SetFont(fontb, fontSizeTitle)
		t:SetJustifyH("LEFT")
		t:SetJustifyV("CENTER")
		t:SetShadowColor(0,0,0,1)
		t:SetShadowOffset(1,-1)
		t:SetTextColor(db.fontColor.r,db.fontColor.g,db.fontColor.b,db.fontColor.a)
		t:SetText(title)
		
		tinsert(self.options, t)
	end

	local function spawnText(self, text)
		text = text or "Text NYI"
		
		t = self:CreateFontString(nil, "OVERLAY", "GameFontNormal")
		t:SetWidth(optionWidth)
		t:SetHeight(optionHeight)
		if #self.options>0 then
			t:SetPoint("TOPLEFT", self.options[#self.options], "BOTTOMLEFT", 0, 0)
		else
			t:SetPoint("TOPLEFT", self, "TOPLEFT", borderSize, -borderSize)
		end
		t:SetFont(font, fontSizeOption)
		t:SetJustifyH("LEFT")
		t:SetJustifyV("CENTER")
		t:SetShadowColor(0,0,0,1)
		t:SetShadowOffset(1,-1)
		t:SetTextColor(db.fontColor.r,db.fontColor.g,db.fontColor.b,db.fontColor.a)
		t:SetText(text)
		
		tinsert(self.options, t)
	end

	local function spawnCheckbox(self, text, dbase, key, tooltip, group)
		text = text or "Text NYI"
		dbase = dbase or {}
		key = key or "test"
		tooltip = tooltip or "Tooltip NYI"
		local parent = self
		
		t = CreateFrame("Frame", nil, self)
		t:SetWidth(optionWidth)
		t:SetHeight(optionHeight)
		if #self.options>0 then
			t:SetPoint("TOPLEFT", self.options[#self.options], "BOTTOMLEFT", 0, 0)
		else
			t:SetPoint("TOPLEFT", self, "TOPLEFT", borderSize, -borderSize)
		end
		t:SetAlpha(1)
		local frame = t
		
		if group then frame.group = group end
		frame.dbase = dbase
		frame.key = key
		
		t = CreateFrame("CheckButton", nil, frame, "OptionsCheckButtonTemplate")
		t:SetWidth(optionHeight)
		t:SetHeight(optionHeight)
		t:SetHitRectInsets(0, -optionWidth+optionHeight, 0, 0)
		t:SetPoint("LEFT", frame, "LEFT", 0, 0)
		local function onClick(self, button, down)
			local checked = self:GetChecked()
			
			for i=1,#parent.options do
				if parent.options[i].group and parent.options[i].group==group then
					parent.options[i].button:SetChecked(nil)
					parent.options[i].dbase[parent.options[i].key] = parent.options[i].button:GetChecked() or false
				end
			end
			
			dbase[key] = checked or false -- Do not make option==nil or the default value will be loaded again!
			
			self:SetChecked(dbase[key])
			
			-- Follow up
			sqwNameplates:refreshNameplateLayouts()
		end
		t:HookScript("OnClick", onClick)
		t:HookScript("OnShow", function(self)
			self:SetChecked(dbase[key])
		end)
		t:HookScript("OnEnter", function(self)
			GameTooltip:SetOwner(self, "ANCHOR_LEFT")
			GameTooltip:AddLine(tooltip)
			GameTooltip:Show()
		end)
		t:HookScript("OnLeave", function() GameTooltip:Hide() end)
		frame.button = t
		local button = t
		
		t = frame:CreateFontString(nil, "OVERLAY", "GameFontNormal")
		t:SetWidth(optionWidth-optionHeight)
		t:SetHeight(optionHeight)
		t:SetPoint("LEFT", button, "RIGHT", 0, 0)
		t:SetFont(font, fontSizeOption)
		t:SetJustifyH("LEFT")
		t:SetJustifyV("CENTER")
		t:SetShadowColor(0,0,0,1)
		t:SetShadowOffset(1,-1)
		t:SetTextColor(db.fontColor.r,db.fontColor.g,db.fontColor.b,db.fontColor.a)
		t:SetText(text)
		
		tinsert(self.options, frame)
	end

	local function spawnDropdown(self, text, tooltip, dropDownFunction)
		text = text or "Text NYI"
		dbase = dbase or {}
		key = key or "test"
		tooltip = tooltip or "Tooltip NYI"
		local parent = self
		local name = key.."DropDownMenu"
		
		local dropDown = CreateFrame("Frame", nil)
		dropDown.displayMode = "MENU"
		dropDown.initialize = dropDownFunction or nil
		
		t = CreateFrame("Button", nil, self)
		t:SetWidth(optionWidth)
		t:SetHeight(optionHeight)
		if #self.options>0 then
			t:SetPoint("TOPLEFT", self.options[#self.options], "BOTTOMLEFT", 0, 0)
		else
			t:SetPoint("TOPLEFT", self, "TOPLEFT", borderSize, -borderSize)
		end
		t:SetAlpha(1)
		t:HookScript("OnClick", function(self)
			ToggleDropDownMenu(1, nil, dropDown, self, 0, 0)
		end)
		t:HookScript("OnEnter", function(self)
			GameTooltip:SetOwner(self, "ANCHOR_LEFT")
			GameTooltip:AddLine(tooltip)
			GameTooltip:Show()
		end)
		t:HookScript("OnLeave", function() GameTooltip:Hide() end)
		local frame = t
		
		t = frame:CreateTexture(nil, "BACKGROUND")
		t:SetWidth(optionHeight)
		t:SetHeight(optionHeight)
		t:SetTexture("Interface\\ChatFrame\\UI-ChatIcon-ScrollDown-Up")
		t:SetPoint("LEFT", frame, "LEFT", 0, 0)
		frame.bg = t
		local bg = t
		
		t = frame:CreateFontString(nil, "OVERLAY", "GameFontNormal")
		t:SetWidth(optionWidth-optionHeight)
		t:SetHeight(optionHeight)
		t:SetPoint("LEFT", bg, "RIGHT", 0, 0)
		t:SetFont(font, fontSizeOption)
		t:SetJustifyH("LEFT")
		t:SetJustifyV("CENTER")
		t:SetShadowColor(0,0,0,1)
		t:SetShadowOffset(1,-1)
		t:SetTextColor(db.fontColor.r,db.fontColor.g,db.fontColor.b,db.fontColor.a)
		t:SetText(text)
		
		tinsert(self.options, frame)
	end

	local function spawnSlider(self, text, variable, tooltip, min, max, step)
		text = text or "Text NYI"
		dbase = dbase or {}
		key = key or nil
		tooltip = tooltip or "Tooltip NYI"
		if min==1 then min = 2 end
		step = step or 1
		
		t = CreateFrame("Frame", nil, self)
		t:SetWidth(optionWidth)
		t:SetHeight(optionHeight*1)
		if #self.options>0 then
			t:SetPoint("TOPLEFT", self.options[#self.options], "BOTTOMLEFT", 0, 0)
		else
			t:SetPoint("TOPLEFT", self, "TOPLEFT", borderSize, -borderSize)
		end
		t:SetAlpha(1)
		local frame = t
		
		if variable then frame.variable = variable end
		
		t = CreateFrame("Slider", "sqwNameplates_slider_"..variable, frame, "OptionsSliderTemplate")
		t:EnableMouseWheel(true)
		t:SetWidth(optionWidth)
		t:SetHeight(optionHeight*0.5)
		t:SetPoint("LEFT", frame, "LEFT", 0, 0)
		t:SetMinMaxValues(min, max)
		t:SetValueStep(step)
		t:SetValue(db[frame.variable])
		local function onValueChanged(self, stp)
			db[frame.variable] = resources.round(self:GetValue(), 3)
			
			getglobal(frame.slider:GetName() .. "Text"):SetText(text.." ("..db[frame.variable]..")")
			
			-- Follow up
			sqwNameplates:refreshNameplateLayouts()
		end
		local function onMouseWheel(self, stp)
			stp = resources.round(step*stp, 3)

			if (db[frame.variable]+stp)<min or (db[frame.variable]+stp)>max then
				db[frame.variable] = db[frame.variable]
			else
				db[frame.variable] = db[frame.variable]+stp
			end
			
			frame.slider:SetValue(db[frame.variable])
			
			getglobal(frame.slider:GetName() .. "Text"):SetText(text.." ("..db[frame.variable]..")")
			
			-- Follow up
			sqwNameplates:refreshNameplateLayouts()
		end
		t:HookScript("OnValueChanged", onValueChanged)
		t:HookScript("OnMouseWheel", onMouseWheel)
		t:HookScript("OnShow", function(self)
			frame.slider:SetValue(db[frame.variable])
			
			getglobal(frame.slider:GetName() .. "Text"):SetText(text.." ("..db[frame.variable]..")")
		end)
		t:HookScript("OnEnter", function(self)
			GameTooltip:SetOwner(self, "ANCHOR_BOTTOMRIGHT")
			GameTooltip:AddLine(tooltip)
			GameTooltip:Show()
		end)
		t:HookScript("OnLeave", function() GameTooltip:Hide() end)
		frame.slider = t
		
		t = getglobal(frame.slider:GetName() .. "Low")
		t:SetText(min)
		t:SetFont(font, fontSizeOption-1)
		t:SetShadowColor(0,0,0,1)
		t:SetShadowOffset(1,-1)
		t:SetTextColor(db.fontColor.r,db.fontColor.g,db.fontColor.b,db.fontColor.a)
		
		t = getglobal(frame.slider:GetName() .. "High")
		t:SetText(max)
		t:SetFont(font, fontSizeOption-1)
		t:SetShadowColor(0,0,0,1)
		t:SetShadowOffset(1,-1)
		t:SetTextColor(db.fontColor.r,db.fontColor.g,db.fontColor.b,db.fontColor.a)
		
		t = getglobal(frame.slider:GetName() .. "Text")
		t:SetText(text.." ("..frame.slider:GetValue()..")")
		t:SetFont(font, fontSizeOption)
		t:SetShadowColor(0,0,0,1)
		t:SetShadowOffset(1,-1)
		t:SetTextColor(db.fontColor.r,db.fontColor.g,db.fontColor.b,db.fontColor.a)
		
		tinsert(self.options, frame)
	end

	local function spawnColorpicker(self, text, dbase, key, tooltip)
		text = text or "Text NYI"
		dbase = dbase or {}
		key = key or "test"
		tooltip = tooltip or "Tooltip NYI"
		local parent = self
		
		local function ColorSwatch_OnClick(self)
			HideUIPanel(ColorPickerFrame)
			
			ColorPickerFrame:SetFrameStrata("FULLSCREEN_DIALOG")
			
			ColorPickerFrame.previousValues = { db[key].r, db[key].g, db[key].b, db[key].a }
			
			ColorPickerFrame.func = function()
				local r, g, b = ColorPickerFrame:GetColorRGB()
				local a = 1 - OpacitySliderFrame:GetValue()
				
				self.tex:SetVertexColor(r, g, b, a or 1)
				db[key].r = r
				db[key].g = g
				db[key].b = b
				db[key].a = a
				
				-- Follow up
				sqwNameplates:refreshNameplateLayouts()
			end
			
			ColorPickerFrame.hasOpacity = true
			ColorPickerFrame.opacityFunc = function()
				local r, g, b = ColorPickerFrame:GetColorRGB()
				local a = 1 - OpacitySliderFrame:GetValue()
				
				self.tex:SetVertexColor(r, g, b, a or 1)
				db[key].r = r
				db[key].g = g
				db[key].b = b
				db[key].a = a
				
				-- Follow up
				sqwNameplates:refreshNameplateLayouts()
			end
			
			local r, g, b, a = db[key].r, db[key].g, db[key].b, db[key].a
			ColorPickerFrame.opacity = 1-(a or 0)
			ColorPickerFrame:SetColorRGB(r, g, b)
			
			ColorPickerFrame.cancelFunc = function()
				local r, g, b, a = unpack(ColorPickerFrame.previousValues)
				
				self.tex:SetVertexColor(r, g, b, a or 1)
				db[key].r = r
				db[key].g = g
				db[key].b = b
				db[key].a = a
				
				-- Follow up
				sqwNameplates:refreshNameplateLayouts()
			end
			
			ShowUIPanel(ColorPickerFrame)
		end
		
		t = CreateFrame("Button", nil, self)
		t:SetWidth(optionWidth)
		t:SetHeight(optionHeight)
		if #self.options>0 then
			t:SetPoint("TOPLEFT", self.options[#self.options], "BOTTOMLEFT", 0, 0)
		else
			t:SetPoint("TOPLEFT", self, "TOPLEFT", borderSize, -borderSize)
		end
		t:SetAlpha(1)
		t:HookScript("OnClick", ColorSwatch_OnClick)
		t:HookScript("OnShow", function(self)
			self.tex:SetVertexColor(db[key].r, db[key].g, db[key].b, db[key].a)
		end)
		t:HookScript("OnEnter", function(self)
			GameTooltip:SetOwner(self, "ANCHOR_LEFT")
			GameTooltip:AddLine(tooltip)
			GameTooltip:Show()
		end)
		t:HookScript("OnLeave", function() GameTooltip:Hide() end)
		local frame = t
		
		t = frame:CreateTexture(nil, "BACKGROUND")
		t:SetWidth(optionHeight-4)
		t:SetHeight(optionHeight-4)
		t:SetTexture("Tileset\\Generic\\Checkers")
		t:SetPoint("LEFT", frame, "LEFT", 4, 0)
		frame.bg = t
		local bg = t
		
		t = frame:CreateTexture(nil, "OVERLAY")
		t:SetWidth(optionHeight+2)
		t:SetHeight(optionHeight+2)
		t:SetTexture("Interface\\ChatFrame\\ChatFrameColorSwatch")
		t:SetPoint("CENTER", bg, "CENTER", 0, 0)
		frame.tex = t
		local tex = t
		
		t = frame:CreateFontString(nil, "OVERLAY", "GameFontNormal")
		t:SetWidth(optionWidth-optionHeight)
		t:SetHeight(optionHeight)
		t:SetPoint("LEFT", bg, "RIGHT", 4, 0)
		t:SetFont(font, fontSizeOption)
		t:SetJustifyH("LEFT")
		t:SetJustifyV("CENTER")
		t:SetShadowColor(0,0,0,1)
		t:SetShadowOffset(1,-1)
		t:SetTextColor(db.fontColor.r,db.fontColor.g,db.fontColor.b,db.fontColor.a)
		t:SetText(text)
		
		tinsert(self.options, frame)
	end

	local function spawnButton(self, text, tooltip, onClick)
		text = text or "Text NYI"
		tooltip = tooltip or "Tooltip NYI"
		onClick = onClick or nil
		local parent = self
		
		t = CreateFrame("Button", nil, self)
		t:SetWidth(optionWidth)
		t:SetHeight(optionHeight)
		if #self.options>0 then
			t:SetPoint("TOPLEFT", self.options[#self.options], "BOTTOMLEFT", 0, 0)
		else
			t:SetPoint("TOPLEFT", self, "TOPLEFT", borderSize, -borderSize)
		end
		t:SetAlpha(1)
		local button = t
		t:HookScript("OnClick", onClick)
		t:HookScript("OnEnter", function(self)
			button.tex:SetVertexColor(1,1,1,0.33)
			
			GameTooltip:SetOwner(self, "ANCHOR_LEFT")
			GameTooltip:AddLine(tooltip)
			GameTooltip:Show()
		end)
		t:HookScript("OnLeave", function()
			button.tex:SetVertexColor(1,1,1,0.1)
			
			GameTooltip:Hide()
		end)
		t:HookScript("OnMouseDown", function()
			button.tex:SetVertexColor(0,1,0,0.33)
		end)
		t:HookScript("OnMouseUp", function()
			button.tex:SetVertexColor(1,1,1,0.33)
		end)
		
		t = button:CreateTexture(nil, "OVERLAY")
		t:SetTexture("Interface\\Addons\\sqwNameplates\\media\\bg")
		t:SetAllPoints(button)
		t:SetVertexColor(1,1,1,0.1)
		button.tex = t
		local tex = t
		
		t = button:CreateFontString(nil, "OVERLAY", "GameFontNormal")
		t:SetWidth(optionWidth)
		t:SetHeight(optionHeight)
		t:SetPoint("CENTER", button, "CENTER", 0, 0)
		t:SetFont(font, fontSizeOption)
		t:SetJustifyH("CENTER")
		t:SetJustifyV("CENTER")
		t:SetShadowColor(0,0,0,1)
		t:SetShadowOffset(1,-1)
		t:SetTextColor(db.fontColor.r,db.fontColor.g,db.fontColor.b,db.fontColor.a)
		t:SetText(text)
		
		tinsert(self.options, t)
	end

	local function spawnEditbox(self, text, dbase, key, tooltip)
		text = text or "Text NYI"
		dbase = dbase or {}
		key = key or "test"
		tooltip = tooltip or "Tooltip NYI"
		local parent = self
		
		t = CreateFrame("EditBox", nil, self, "InputBoxTemplate")
		t:SetWidth(optionWidth)
		t:SetHeight(optionHeight)
		if #self.options>0 then
			t:SetPoint("TOPLEFT", self.options[#self.options], "BOTTOMLEFT", 0, 0)
		else
			t:SetPoint("TOPLEFT", self, "TOPLEFT", borderSize, -borderSize)
		end
		t:SetAlpha(1)
		t:SetAutoFocus(false)
		local frame = t
		t:HookScript("OnShow", function(self)
			self:SetText(text)
			self:HighlightText()
		end)
		t:HookScript("OnEnter", function(self)
			GameTooltip:SetOwner(self, "ANCHOR_LEFT")
			GameTooltip:AddLine(tooltip)
			GameTooltip:Show()
		end)
		t:HookScript("OnLeave", function(self) GameTooltip:Hide() end)
		t:HookScript("OnMouseUp", function(self)
			self:SetText("")
		end)
		t:HookScript("OnEnterPressed", function(self)
			local n = self:GetText()
			if n and n~=text then
				dbase[key] = n
			else
				dbase[key] = nil
			end
			filterAddOnClick(self)
			
			self:SetText("")
			self:ClearFocus()
		end)

		tinsert(self.options, frame)
	end

	local function spawnEditbox2(self, text, dbase, key, tooltip)
		text = text or "Text NYI"
		dbase = dbase or {}
		key = key or "test"
		tooltip = tooltip or "Tooltip NYI"
		local parent = self
		
		t = CreateFrame("EditBox", nil, self, "InputBoxTemplate")
		t:SetWidth(optionWidth)
		t:SetHeight(optionHeight)
		if #self.options>0 then
			t:SetPoint("TOPLEFT", self.options[#self.options], "BOTTOMLEFT", 0, 0)
		else
			t:SetPoint("TOPLEFT", self, "TOPLEFT", borderSize, -borderSize)
		end
		t:SetAlpha(1)
		t:SetAutoFocus(false)
		local frame = t
		t:HookScript("OnShow", function(self)
			self:SetText(text)
			self:HighlightText()
		end)
		t:HookScript("OnEnter", function(self)
			GameTooltip:SetOwner(self, "ANCHOR_LEFT")
			GameTooltip:AddLine(tooltip)
			GameTooltip:Show()
		end)
		t:HookScript("OnLeave", function(self) GameTooltip:Hide() end)
		t:HookScript("OnMouseUp", function(self)
			self:SetText("")
		end)
		t:HookScript("OnEnterPressed", function(self)
			local n = self:GetText()
			if n and n~=text then
				dbase[key][n] = true
			else
				dbase[key][n] = nil
			end
			
			self:SetText("")
			self:ClearFocus()
			
			-- Follow up
			sqwNameplates:refreshNameplateLayouts()
		end)
		
		tinsert(self.options, frame)
	end

	local function spawnEditbox3(self, text, dbase, key, tooltip)
		text = text or "Text NYI"
		dbase = dbase or {}
		key = key or "test"
		tooltip = tooltip or "Tooltip NYI"
		local parent = self
		
		t = CreateFrame("EditBox", nil, self, "InputBoxTemplate")
		t:SetWidth(optionWidth)
		t:SetHeight(optionHeight)
		if #self.options>0 then
			t:SetPoint("TOPLEFT", self.options[#self.options], "BOTTOMLEFT", 0, 0)
		else
			t:SetPoint("TOPLEFT", self, "TOPLEFT", borderSize, -borderSize)
		end
		t:SetAlpha(1)
		t:SetAutoFocus(false)
		local frame = t
		t:HookScript("OnShow", function(self)
			self:SetText(text)
			self:HighlightText()
		end)
		t:HookScript("OnEnter", function(self)
			GameTooltip:SetOwner(self, "ANCHOR_LEFT")
			GameTooltip:AddLine(tooltip)
			GameTooltip:Show()
		end)
		t:HookScript("OnLeave", function(self) GameTooltip:Hide() end)
		t:HookScript("OnMouseUp", function(self)
			self:SetText("")
		end)
		t:HookScript("OnEnterPressed", function(self)
			local n = self:GetText()
			if n and n~=text and strfind(n, ",") then
				local a, b = strsplit(",", n)
				
				dbase[key][a] = b
			else
				--dbase[key][n] = nil
			end
			
			self:SetText("")
			self:ClearFocus()
			
			-- Follow up
			sqwNameplates:refreshNameplateLayouts()
		end)
		
		tinsert(self.options, frame)
	end

	local function spawnEditbox4(self, text, dbase, key, tooltip)
		text = text or "Text NYI"
		dbase = dbase or {}
		key = key or "test"
		tooltip = tooltip or "Tooltip NYI"
		local parent = self
		
		t = CreateFrame("EditBox", nil, self, "InputBoxTemplate")
		t:SetWidth(optionWidth)
		t:SetHeight(optionHeight)
		if #self.options>0 then
			t:SetPoint("TOPLEFT", self.options[#self.options], "BOTTOMLEFT", 0, 0)
		else
			t:SetPoint("TOPLEFT", self, "TOPLEFT", borderSize, -borderSize)
		end
		t:SetAlpha(1)
		t:SetAutoFocus(false)
		local frame = t
		t:HookScript("OnShow", function(self)
			self:SetText(text)
			self:HighlightText()
		end)
		t:HookScript("OnEnter", function(self)
			GameTooltip:SetOwner(self, "ANCHOR_LEFT")
			GameTooltip:AddLine(tooltip)
			GameTooltip:Show()
		end)
		t:HookScript("OnLeave", function(self) GameTooltip:Hide() end)
		t:HookScript("OnMouseUp", function(self)
			self:SetText("")
		end)
		t:HookScript("OnEnterPressed", function(self)
			local n = self:GetText()
			if n and n~=text then
				tinsert(dbase[key], n)
			end
			
			self:SetText("")
			self:ClearFocus()
		end)
		
		
		tinsert(self.options, frame)
	end

	local function createFrames() -- Options are created here
		global = sqwNameplates.db.global
		
		t = CreateFrame("Frame", "sqwNameplates_options", UIParent)
		t:Hide()
		t:SetFrameStrata("FULLSCREEN_DIALOG")
		t:SetAlpha(1)
		t:SetPoint("TOPLEFT", UIParent)
		t:SetPoint("BOTTOMRIGHT", UIParent)
		t:HookScript("OnShow", function(self)
			db = sqwNameplates.db.profile
			
			sqwNameplates.configMode = true
			
			sqwNameplates:refreshNameplateLayouts()
		end)
		t:HookScript("OnHide", function(self)
			sqwNameplates.configMode = false
			
			sqwNameplates:refreshNameplateLayouts()
		end)
		tinsert(UISpecialFrames, t:GetName())
		optionFrames.main = t
		
		--[[t = optionFrames.main:CreateTexture(nil, "OVERLAY")
		t:SetTexture(db.logo)
		t:SetPoint("TOP", optionFrames.main, "TOP", 0, -10)
		t:SetTexCoord(0, 1, 0, 0.52)
		t:SetWidth(512)
		t:SetHeight(64)
		t:SetVertexColor(1, 1, 1, 1)
		optionFrames.main.logo = t]]
		
		t = CreateFrame("Button", nil, optionFrames.main, "OptionsButtonTemplate")
		t:SetWidth(80)
		t:SetHeight(22)
		t:SetPoint("TOPRIGHT", optionFrames.main, "TOPRIGHT", -20, -20)
		t:SetText(CLOSE)
		t:HookScript("OnClick", function(self)
			optionFrames.main:Hide()
		end)
		local close = t
		
		t = CreateFrame("Button", nil, optionFrames.main, "OptionsButtonTemplate")
		t:SetWidth(80)
		t:SetHeight(22)
		t:SetPoint("TOPRIGHT", close, "TOPLEFT", -20, 0)
		t:SetText(L["Profiles"])
		t:HookScript("OnClick", function(self)
			optionFrames.main:Hide()
			
			InterfaceOptionsFrame_OpenToCategory("sqwNameplates")
		end)
		local profiles = t
		
		t = CreateFrame("Button", nil, optionFrames.main, "OptionsButtonTemplate")
		t:SetWidth(80)
		t:SetHeight(22)
		t:SetPoint("TOPRIGHT", profiles, "TOPLEFT", -20, 0)
		t:SetText(L["Presets"])
		t:HookScript("OnClick", function(self)
			optionFrames.main:Hide()
			
			sqwNameplates:LoadPreset()
		end)
		
		-- Layout
		optionFrames.main.layout = spawnContainer(optionFrames.main)
		optionFrames.main.layout:SetPoint("TOPLEFT", optionFrames.main, 50, -80)
		spawnTitle(optionFrames.main.layout, L["Layout"])
		
		spawnCheckbox(optionFrames.main.layout, GUILD, db, "guildName", L["guildName"])
		spawnCheckbox(optionFrames.main.layout, L["Level"], db, "showLevel", L["showLevel"])
		spawnCheckbox(optionFrames.main.layout, L["Target Name HL"], db, "targetNHL", L["targetNHL"])
		spawnCheckbox(optionFrames.main.layout, L["Target Name HL2"], db, "targetNHL2", L["targetNHL2"])
		spawnCheckbox(optionFrames.main.layout, L["Target Marker"].." "..L["icon"], db, "targetIcon", L["targetIcon"])
	--spawnCheckbox(optionFrames.main.layout, L["Mouseover HL Texture A"], db, "npHLTexA", L["npHLTexA"])
	--spawnCheckbox(optionFrames.main.layout, L["Mouseover HL Texture B"], db, "npHLTexB", L["npHLTexB"])
		spawnCheckbox(optionFrames.main.layout, L["Social"].." "..L["icon"], db, "socialIcon", L["socialIcon"])
		spawnCheckbox(optionFrames.main.layout, L["Class"].." "..L["icon"], db, "classIcon", L["classIcon"])
		spawnCheckbox(optionFrames.main.layout, L["Role"].." "..L["icon"], db, "roleIcon", L["roleIcon"])
		spawnCheckbox(optionFrames.main.layout, L["Unknown"].." "..L["icon"], db, "unknownIcon", L["unknownIcon"])
		spawnCheckbox(optionFrames.main.layout, L["Debug"], db, "debugMode", L["debugMode"])
		spawnTitle(optionFrames.main.layout, " ")
		spawnTitle(optionFrames.main.layout, L["Textures"])
		spawnDropdown(optionFrames.main.layout, L["Statusbar"], L["StatusbarTt"], texDropDownMenu)
		spawnDropdown(optionFrames.main.layout, L["Border"], L["StatusbarTt"], borderDropDownMenu)
		spawnTitle(optionFrames.main.layout, " ")
		spawnTitle(optionFrames.main.layout, L["Size"])
		spawnTitle(optionFrames.main.layout, " ")
		spawnSlider(optionFrames.main.layout, HEALTH.." "..L["Height"], "height", L["scale_tt"], 2, 50, 1)
		spawnSlider(optionFrames.main.layout, HEALTH.." "..L["Width"], "width", L["scale_tt"], 10, 200, 1)
		spawnSlider(optionFrames.main.layout, L["Castbar"].." "..L["Height"], "heightCast", L["scale_tt"], 2, 50, 1)
		spawnSlider(optionFrames.main.layout, L["Castbar"].." "..L["Width"], "widthCast", L["scale_tt"], 10, 200, 1)
		spawnSlider(optionFrames.main.layout, L["Scale"], "scale", L["scale_tt"], 0.2, 4, 0.05)
		spawnSlider(optionFrames.main.layout, L["Scale"].." "..L["Buffs"], "scaleBuffs", L["scale_tt"], 0.2, 4, 0.05)
		spawnTitle(optionFrames.main.layout, " ")
		spawnTitle(optionFrames.main.layout, " ")
		spawnTitle(optionFrames.main.layout, L["Miscellaneous"])
		spawnCheckbox(optionFrames.main.layout, L["Combatlog fix"], db, "combatLogFix", L["combatLogFix"])
		spawnCheckbox(optionFrames.main.layout, L["Combatlog print"], db, "combatLogFixPrint", L["combatLogFixPrint"])
		spawnTitle(optionFrames.main.layout, " ")
		spawnTitle(optionFrames.main.layout, L["Alpha"])
		spawnSlider(optionFrames.main.layout, L["Alpha"], "alpha", L["scale_tt"], 0.001, 1, 0.1)
		spawnTitle(optionFrames.main.layout, L["MouseoverAlpha"])
		spawnSlider(optionFrames.main.layout, L["MouseoverAlpha"], "MoAlpha", L["scale_tt"], 0.001, 1, 0.1)
		
		-- Colors
		optionFrames.main.colors = spawnContainer(optionFrames.main)
		optionFrames.main.colors:SetPoint("TOPLEFT", optionFrames.main.layout, "TOPRIGHT", borderSize, 0)
		spawnTitle(optionFrames.main.colors, L["Color"])
		spawnColorpicker(optionFrames.main.colors, L["Font"], db, "fontColor", L["colorTt"])
		spawnColorpicker(optionFrames.main.colors, L["Custom Health Bar"], db, "customColor", L["colorTt"])
		spawnColorpicker(optionFrames.main.colors, L["Custom Health Bar Number"], db, "HBNumberColorCustom", L["colorTt"])
		spawnColorpicker(optionFrames.main.colors, L["Background"], db, "bgColor", L["colorTt"])
		spawnColorpicker(optionFrames.main.colors, L["Border"], db, "borderColor", L["colorTt"])
		spawnColorpicker(optionFrames.main.colors, L["Threat"].." "..L["very safe"], db, "colorThreatVerySafe", L["colorTt"])
		spawnColorpicker(optionFrames.main.colors, L["Threat"].." "..L["safe"], db, "colorThreatSafe", L["colorTt"])
		spawnColorpicker(optionFrames.main.colors, L["Threat"].." "..L["unsafe"], db, "colorThreatUnsafe", L["colorTt"])
		spawnColorpicker(optionFrames.main.colors, L["Threat"].." "..L["alert"], db, "colorThreatAlert", L["colorTt"])
		spawnColorpicker(optionFrames.main.colors, L["Threat"].." "..L["tanked"], db, "colorThreatTanked", L["colorTt"])
		spawnColorpicker(optionFrames.main.colors, L["Castbar"], db, "castColor", L["colorTt"])
		
		-- Font
		optionFrames.main.font = spawnContainer(optionFrames.main)
		optionFrames.main.font:SetPoint("TOPLEFT", optionFrames.main.colors, "BOTTOMLEFT", 0, -borderSize)
		spawnTitle(optionFrames.main.font, L["Font"])
		spawnDropdown(optionFrames.main.font, L["Normal"], L["fontTt"], fontDropDownMenu)
		spawnDropdown(optionFrames.main.font, L["Bold"], L["fontTt"], fontbDropDownMenu)
		spawnDropdown(optionFrames.main.font, L["Italic"], L["fontTt"], fontiDropDownMenu)
		spawnSlider(optionFrames.main.font, L["Name"], "fontsizeName", L["size_tt"], 8, 28)
		spawnSlider(optionFrames.main.font, L["Guild"], "fontsizeGuild", L["size_tt"], 8, 28)
		spawnSlider(optionFrames.main.font, HEALTH, "fontsizeHealth", L["size_tt"], 8, 28)
		spawnSlider(optionFrames.main.font, L["Castbar"], "fontsizeCast", L["size_tt"], 8, 28)
		spawnSlider(optionFrames.main.font, L["Buffs"], "fontsizeBuffs", L["size_tt"], 8, 28)
		spawnDropdown(optionFrames.main.font, L["Outline"], L["fontTt"], outlineDropDownMenu)
		

		-- Health
		optionFrames.main.health = spawnContainer(optionFrames.main)
		optionFrames.main.health:SetPoint("TOPLEFT", optionFrames.main.colors, "TOPRIGHT", borderSize, 0)
		spawnTitle(optionFrames.main.health, HEALTH)
		spawnCheckbox(optionFrames.main.health, HEALTH.." "..L["percent"], db, "showHpPercent", L["showHpPercent"], "hpNumber")
		spawnCheckbox(optionFrames.main.health, HEALTH.." "..L["absolut"], db, "showHpAbsolut", L["showHpAbsolut"], "hpNumber")
		--spawnCheckbox(optionFrames.main.health, HEALTH.." "..L["absolut / percent"], db, "showHpAbsolutPercent", L["showHpAbsolutPercent"], "hpNumber")
		spawnCheckbox(optionFrames.main.health, L["Healthbar"], db, "showHpBar", L["showHpBar"])
		spawnText(optionFrames.main.health, L["Color"])
		spawnCheckbox(optionFrames.main.health, L["Custom Health Bar"], db, "healthBarColorCustom", L["healthBarColorCustom"])
		spawnCheckbox(optionFrames.main.health, L["Custom Health Bar Number"], db, "healthBarNumberColorCustom", L["healthBarNumberColorCustom"])
		spawnCheckbox(optionFrames.main.health, L["Threat"], db, "threatEnabled", L["threatEnabled"])
		spawnCheckbox(optionFrames.main.health, L["PvP"], db, "healthBarColorPvP", L["healthBarColorPvP"])
		spawnCheckbox(optionFrames.main.health, L["Class"], db, "healthBarColorClass", L["healthBarColorClass"])
		spawnText(optionFrames.main.health, L["Visibility"])
		spawnCheckbox(optionFrames.main.health, L["Friend"].." "..L["PvE"], db, "healthBarFriendPve", L["healthBar"])
		spawnCheckbox(optionFrames.main.health, L["Enemy"].." "..L["PvE"], db, "healthBarEnemyPve", L["healthBar"])
		spawnCheckbox(optionFrames.main.health, L["Friend"].." "..L["PvE"].." "..L["combat"], db, "healthBarFriendPveCombat", L["healthBar"])
		spawnCheckbox(optionFrames.main.health, L["Enemy"].." "..L["PvE"].." "..L["combat"], db, "healthBarEnemyPveCombat", L["healthBar"])
		spawnCheckbox(optionFrames.main.health, L["Friend"].." "..L["PvP"], db, "healthBarFriendPvp", L["healthBar"])
		spawnCheckbox(optionFrames.main.health, L["Enemy"].." "..L["PvP"], db, "healthBarEnemyPvp", L["healthBar"])
		
		-- Castbar
		optionFrames.main.cast = spawnContainer(optionFrames.main)
		optionFrames.main.cast:SetPoint("TOPLEFT", optionFrames.main.health, "BOTTOMLEFT", 0, -borderSize)
		spawnTitle(optionFrames.main.cast, L["Castbar"])
		spawnCheckbox(optionFrames.main.cast, L["Non-Targets"], db, "castBarNonTargets", L["castBarNonTargets"])
		spawnText(optionFrames.main.cast, L["Visibility"])
		spawnCheckbox(optionFrames.main.cast, L["Friend"].." "..L["PvE"], db, "castBarFriendPve", L["castBar"])
		spawnCheckbox(optionFrames.main.cast, L["Enemy"].." "..L["PvE"], db, "castBarEnemyPve", L["castBar"])
		spawnCheckbox(optionFrames.main.cast, L["Friend"].." "..L["PvE"].." "..L["combat"], db, "castBarFriendPveCombat", L["castBar"])
		spawnCheckbox(optionFrames.main.cast, L["Enemy"].." "..L["PvE"].." "..L["combat"], db, "castBarEnemyPveCombat", L["castBar"])
		spawnCheckbox(optionFrames.main.cast, L["Friend"].." "..L["PvP"], db, "castBarFriendPvp", L["castBar"])
		spawnCheckbox(optionFrames.main.cast, L["Enemy"].." "..L["PvP"], db, "castBarEnemyPvp", L["castBar"])
		
		-- Visibility
		optionFrames.main.vis = spawnContainer(optionFrames.main)
		optionFrames.main.vis:SetPoint("TOPRIGHT", optionFrames.main, -50, -80)
		spawnTitle(optionFrames.main.vis, L["Visibility"])
		spawnCheckbox(optionFrames.main.vis, L["Overlap"], db, "allowOverlap", L["allowOverlap"])
		spawnTitle(optionFrames.main.vis, L["PvE"])
		spawnCheckbox(optionFrames.main.vis, L["Friend"].." "..L["Unit"], db, "visPveFriendUnit", L["visTt"])
		spawnCheckbox(optionFrames.main.vis, L["Friend"].." "..L["Pet"], db, "visPveFriendPet", L["visTt"])
		spawnCheckbox(optionFrames.main.vis, L["Friend"].." "..L["Guardian"], db, "visPveFriendGuardian", L["visTt"])
		spawnCheckbox(optionFrames.main.vis, L["Friend"].." "..L["Totem"], db, "visPveFriendTotem", L["visTt"])
		spawnCheckbox(optionFrames.main.vis, L["Enemy"].." "..L["Unit"], db, "visPveEnemyUnit", L["visTt"])
		spawnCheckbox(optionFrames.main.vis, L["Enemy"].." "..L["Pet"], db, "visPveEnemyPet", L["visTt"])
		spawnCheckbox(optionFrames.main.vis, L["Enemy"].." "..L["Guardian"], db, "visPveEnemyGuardian", L["visTt"])
		spawnCheckbox(optionFrames.main.vis, L["Enemy"].." "..L["Totem"], db, "visPveEnemyTotem", L["visTt"])
		spawnTitle(optionFrames.main.vis, L["PvE"].." "..L["combat"])
		spawnCheckbox(optionFrames.main.vis, L["Friend"].." "..L["Unit"], db, "visPvecombatFriendUnit", L["visTt"])
		spawnCheckbox(optionFrames.main.vis, L["Friend"].." "..L["Pet"], db, "visPvecombatFriendPet", L["visTt"])
		spawnCheckbox(optionFrames.main.vis, L["Friend"].." "..L["Guardian"], db, "visPvecombatFriendGuardian", L["visTt"])
		spawnCheckbox(optionFrames.main.vis, L["Friend"].." "..L["Totem"], db, "visPvecombatFriendTotem", L["visTt"])
		spawnCheckbox(optionFrames.main.vis, L["Enemy"].." "..L["Unit"], db, "visPvecombatEnemyUnit", L["visTt"])
		spawnCheckbox(optionFrames.main.vis, L["Enemy"].." "..L["Pet"], db, "visPvecombatEnemyPet", L["visTt"])
		spawnCheckbox(optionFrames.main.vis, L["Enemy"].." "..L["Guardian"], db, "visPvecombatEnemyGuardian", L["visTt"])
		spawnCheckbox(optionFrames.main.vis, L["Enemy"].." "..L["Totem"], db, "visPvecombatEnemyTotem", L["visTt"])
		spawnTitle(optionFrames.main.vis, L["PvP"])
		spawnCheckbox(optionFrames.main.vis, L["Friend"].." "..L["Unit"], db, "visPvpFriendUnit", L["visTt"])
		spawnCheckbox(optionFrames.main.vis, L["Friend"].." "..L["Pet"], db, "visPvpFriendPet", L["visTt"])
		spawnCheckbox(optionFrames.main.vis, L["Friend"].." "..L["Guardian"], db, "visPvpFriendGuardian", L["visTt"])
		spawnCheckbox(optionFrames.main.vis, L["Friend"].." "..L["Totem"], db, "visPvpFriendTotem", L["visTt"])
		spawnCheckbox(optionFrames.main.vis, L["Enemy"].." "..L["Unit"], db, "visPvpEnemyUnit", L["visTt"])
		spawnCheckbox(optionFrames.main.vis, L["Enemy"].." "..L["Pet"], db, "visPvpEnemyPet", L["visTt"])
		spawnCheckbox(optionFrames.main.vis, L["Enemy"].." "..L["Guardian"], db, "visPvpEnemyGuardian", L["visTt"])
		spawnCheckbox(optionFrames.main.vis, L["Enemy"].." "..L["Totem"], db, "visPvpEnemyTotem", L["visTt"])
		 
		
		
		-- Buffs
		optionFrames.main.buffs = spawnContainer(optionFrames.main)
		optionFrames.main.buffs:SetPoint("TOPRIGHT", optionFrames.main.vis, "TOPLEFT", -borderSize, 0)
		spawnTitle(optionFrames.main.buffs, L["Buffs"])
		spawnSlider(optionFrames.main.buffs, L["Number"], "buffsNumber", L["buffsNumber"], 1, 12)
		spawnCheckbox(optionFrames.main.buffs, L["Friend"].." "..L["PvE"], db, "buffsFriendPve", L["buffsTt"])
		spawnCheckbox(optionFrames.main.buffs, L["Enemy"].." "..L["PvE"], db, "buffsEnemyPve", L["buffsTt"])
		spawnCheckbox(optionFrames.main.buffs, L["Friend"].." "..L["PvE"].." "..L["combat"], db, "buffsFriendPveCombat", L["buffsTt"])
		spawnCheckbox(optionFrames.main.buffs, L["Enemy"].." "..L["PvE"].." "..L["combat"], db, "buffsEnemyPveCombat", L["buffsTt"])
		spawnCheckbox(optionFrames.main.buffs, L["Friend"].." "..L["PvP"], db, "buffsFriendPvp", L["buffsTt"])
		spawnCheckbox(optionFrames.main.buffs, L["Enemy"].." "..L["PvP"], db, "buffsEnemyPvp", L["buffsTt"])
		spawnCheckbox(optionFrames.main.buffs, L["All my buffs"], db.buffFilter.buffs, "allMy", L["allMyBuffs"])
		spawnCheckbox(optionFrames.main.buffs, L["All my debuffs"], db.buffFilter.debuffs, "allMy", L["allMyDebuffs"])
		spawnCheckbox(optionFrames.main.buffs, L["All any buffs"], db.buffFilter.buffs, "allAny", L["allAnyBuffs"])
		spawnCheckbox(optionFrames.main.buffs, L["All any debuffs"], db.buffFilter.debuffs, "allAny", L["allAnyDebuffs"])
		
		-- Hider
		optionFrames.main.hider = spawnContainer(optionFrames.main)
		optionFrames.main.hider:SetPoint("TOPLEFT", optionFrames.main.buffs, "BOTTOMLEFT", 0, -borderSize)
		spawnTitle(optionFrames.main.hider, L["Hider"])
		spawnEditbox2(optionFrames.main.hider, L["Name"], global, "nameplateHider", L["hiderName"])
		spawnTitle(optionFrames.main.hider, L["Delete"])
		spawnDropdown(optionFrames.main.hider, L["Hider"], L["hiderDeleteTt"], deleteHiderDropDownMenu)
		
		-- Name replacer
		optionFrames.main.short = spawnContainer(optionFrames.main)
		optionFrames.main.short:SetPoint("TOPLEFT", optionFrames.main.hider, "BOTTOMLEFT", 0, -borderSize)
		spawnTitle(optionFrames.main.short, L["Name replacer"])
		spawnEditbox3(optionFrames.main.short, L["Name,Replacement"], global, "nameReplacer", L["replacerName"])
		spawnTitle(optionFrames.main.short, L["Delete"])
		spawnDropdown(optionFrames.main.short, L["Hider"], L["replacerDeleteTt"], deleteReplacerDropDownMenu)
		
		-- Filter
		optionFrames.main.filter = spawnContainer(optionFrames.main)
		optionFrames.main.filter:SetPoint("TOPRIGHT", optionFrames.main.buffs, "TOPLEFT", -borderSize, 0)
		--spawnTitle(optionFrames.main.filter, L["Delete"])
		--spawnDropdown(optionFrames.main.filter, L["Buffs"], L["deleteTt"], deleteBuffsDropDownMenu)
		--spawnDropdown(optionFrames.main.filter, L["Debuffs"], L["deleteTt"], deleteDebuffsDropDownMenu)
		--spawnTitle(optionFrames.main.filter, " ")
		spawnTitle(optionFrames.main.filter, L["Filter"])
		spawnEditbox(optionFrames.main.filter, L["Name"], db.buffFilter, "filterName", L["filterName"])
		--spawnButton(optionFrames.main.filter, L["Add"], L["filterAdd"], filterAddOnClick)
		spawnCheckbox(optionFrames.main.filter, L["Only my"], db.buffFilter, "filterOnlyMy", L["filterOnlyMy"])
		spawnCheckbox(optionFrames.main.filter, L["Buff"], db.buffFilter, "filterBuff", L["filterBuff"])
		spawnCheckbox(optionFrames.main.filter, L["Debuff"], db.buffFilter, "filterDebuff", L["filterDebuff"])
		spawnCheckbox(optionFrames.main.filter, L["Never show"], db.buffFilter, "filterNeverShow", L["filterNeverShow"])
		spawnCheckbox(optionFrames.main.filter, L["High"].." "..L["priority"], db.buffFilter, "filterHigh", L["priorityTt"], "priority")
		spawnCheckbox(optionFrames.main.filter, L["Medium"].." "..L["priority"], db.buffFilter, "filterMedium", L["priorityTt"], "priority")
		spawnCheckbox(optionFrames.main.filter, L["Low"].." "..L["priority"], db.buffFilter, "filterLow", L["priorityTt"], "priority")
		spawnCheckbox(optionFrames.main.filter, L["Emphasize"], db.buffFilter, "emphasize", L["emphasizeTt"], "emphasize")
		
		-- LFG
		optionFrames.main.lfg = spawnContainer(optionFrames.main)
		optionFrames.main.lfg:SetPoint("TOPLEFT", optionFrames.main.filter, "BOTTOMLEFT", 0, -borderSize)
		--optionFrames.main.lfg:SetPoint("TOPLEFT", optionFrames.main.colors, "BOTTOMLEFT", 0, -borderSize)
		spawnTitle(optionFrames.main.lfg, L["LFG"])
		spawnCheckbox(optionFrames.main.lfg, L["Enabled"], db, "lfgIcon", L["lfgIcon"])
		spawnEditbox4(optionFrames.main.lfg, "", global, "LFGList", L["LFGName"])
		spawnTitle(optionFrames.main.lfg, L["Delete"])
		spawnDropdown(optionFrames.main.lfg, L["LFG"], L["LFGDeleteTt"], deleteLFGDropDownMenu)

		-- Arena
		optionFrames.main.arena = spawnContainer(optionFrames.main)
		optionFrames.main.arena:SetPoint("TOPLEFT", optionFrames.main.lfg, "BOTTOMLEFT", 0, -borderSize)
		spawnTitle(optionFrames.main.arena, ARENA)
		spawnCheckbox(optionFrames.main.arena, L["tot"], db, "tot", L["tot"])

	end


	local function blizzardOptions() -- Spawn the options
		sqwNameplates.options = {
			type = "group",
			args = {
				optionssqwNameplates = {
					name = "sqwNameplates",
					desc = "sqwNameplates",
					type = "group",
					order = 0,
					args = {
					   i = {
							type="description",
						   -- image=db.logo,
						   -- imageWidth = 256,
							--imageHeight = 32,
							--imageCoords = {0,1,0,0.52},
							name="",
							order=0,
						},
						config = {
							type="execute",
							name=L["Config"],
							desc="/sqwnp  /np",
							func=function(self)
								InterfaceOptionsFrame:Hide()
								sqwNameplates.optionFrame.main:Show()
							end,
							order=1,
						},
					},
				},
				
			},
		}
	end

	function sqwNameplates:SpawnOptions() -- Spawn the options
		db = sqwNameplates.db.profile
		
		createFrames()
		blizzardOptions()
		
		sqwNameplates.optionFrame = optionFrames
		
		spawnPresetFrame()
	end