
	local L = LibStub("AceLocale-3.0"):GetLocale("sqwNameplates")
	local LSM = LibStub("LibSharedMedia-3.0")
	local t,t2
	local addon = sqwNameplates

	local function p(text) -- Print
		ChatFrame3:AddMessage(tostring(text))
	end
	local u = update
	local UnitGUID = UnitGUID
	local UnitAura = UnitAura
	local UnitBuff = UnitBuff
	local UnitDebuff = UnitDebuff
	local UnitExists = UnitExists
	local UnitIsPlayer = UnitIsPlayer
	local UnitClassification = UnitClassification
	local unpack = unpack
	local tonumber = tonumber
	local tostring = tostring
	local ipairs = ipairs
	local next = next
	local pairs	= pairs
	local sort = sort
	local strfind = strfind
	local strlower = strlower
	local tremove = tremove
	local tinsert = tinsert
	local format = format
	local floor = floor
	local wipe = wipe

	local db, frames, realm, global, playerList, guidBuffs, guidCasts, scanUnitAuras, party, raid, guild, bnet, friend, arena, battleground, isTank, time, tanks
	local isInInstance, isInArena, isInBattleground, isInSanctuary, hasGroup, playerTargetGUID, unitIsDifferent, tankMode, configMode

	local u = {}
	local resources = addon.resources
	local playerName = UnitName("player")
	local _, playerClass = UnitClass("player")
	--iGuild, iFriends = _G.iGuild, _G.iFriends;
	local playerGuild = _G.iGuild
	--local playerGuild = GetGuildInfo("player")
	local playerLevel = UnitLevel("player")
	--local playerGUID = UnitGUID("player")--orig
	--local playerGUID = UnitIsInMyGuild--test
	local playerTarget = false
	local realmName = GetRealmName()
	addon.inCombat = false
	local inCombat = addon.inCombat
	addon.isInPve = true
	local isInPve = addon.isInPve
	addon.isInPvp = false
	local isInPvp = addon.isInPvp
	local tankMode = false
	local tankModeCheckFrequency = 10
	local temporaryList = {}
	local framesShown = {}
	addon.framesShown = framesShown
	addon.GUIDThreat = {}
	local guidThreat = addon.GUIDThreat

	local doUpdate = 0
	local function setDoUpdate(number) doUpdate = max(doUpdate, number) end
	local doUpdateThreat = 0
	local function setDoUpdateThreat(number) doUpdateThreat = max(doUpdateThreat, number) end
	local doUpdateNext = { frames = {}, name = {}, GUID = {} }
	local function setDoUpdateMe(object, type, option)
		if type=="frame" then tinsert(doUpdateNext.frames, { object, option })			--doUpdateNext.frames[object] = option or true
		elseif type=="name" then tinsert(doUpdateNext.name, { object, option })         --doUpdateNext.name[object] = option or true
		elseif type=="GUID" then tinsert(doUpdateNext.GUID, { object, option })         --doUpdateNext.GUID[object] = option or true
		end
	end
	addon.setDoUpdateMe = setDoUpdateMe

	local tooltipScan = CreateFrame("GameTooltip", "sqwScanningTooltip", UIParent, "GameTooltipTemplate")
	sqwScanningTooltip:SetOwner(WorldFrame, "ANCHOR_NONE")

	--NAMEPLATE VISIBILITY
	local function setVisibility() 
		-- isInPve, isInPvp, inCombat
		
		if db.threatEnabled then -- 0=off 1=dungeons 2=party/raid 3=always
			SetCVar("threatWarning", 3) 
		else
			SetCVar("threatWarning", 0) 
		end

		----------------------------------------------
		--[[     if db.allowOverlap then
			SetCVar( "nameplateAllowOverlap", 1)
	  else
		  SetCVar( "nameplateAllowOverlap", 0)
		end]]
		-------------------------------------------------
		
		--PVE IN COMBAT
		if isInPve and not inCombat then

			--PVE IN COMBAT - FRIEND
			if db.visPveFriendUnit then
				SetCVar("nameplateShowFriends", 1)
			else
				SetCVar("nameplateShowFriends", 0)
			end
			if db.visPveFriendPet then
				SetCVar("nameplateShowFriendlyPets", 1)
			else
				SetCVar("nameplateShowFriendlyPets", 0)
			end
			if db.visPveFriendGuardian then
				SetCVar("nameplateShowFriendlyGuardians", 1)
			else
				SetCVar("nameplateShowFriendlyGuardians", 0)
			end
			if db.visPveFriendTotem then
				SetCVar("nameplateShowFriendlyTotems", 1)
			else
				SetCVar("nameplateShowFriendlyTotems", 0)
			end
			
			--PVE IN COMBAT - ENEMY
			if db.visPveEnemyUnit then
				SetCVar("nameplateShowEnemies", 1)
			else
				SetCVar("nameplateShowEnemies", 0)
			end
			if db.visPveEnemyPet then
				SetCVar("nameplateShowEnemyPets", 1)
			else
				SetCVar("nameplateShowEnemyPets", 0)
			end
			if db.visPveEnemyGuardian then
				SetCVar("nameplateShowEnemyGuardians", 1)
			else
				SetCVar("nameplateShowEnemyGuardians", 0)
			end
			if db.visPveEnemyTotem then
				SetCVar("nameplateShowEnemyTotems", 1)
			else
				SetCVar("nameplateShowEnemyTotems", 0)
			end

			--PVE OUT OF COMBAT
		elseif isInPve then
			SetCVar("nameplateShowFriends", 0)

			--PVE OUT OF COMBAT - FRIEND
			if db.visPvecombatFriendUnit then
				SetCVar("nameplateShowFriends", 1)
			else
				SetCVar("nameplateShowFriends", 0)
			end
			if db.visPvecombatFriendPet then
				SetCVar("nameplateShowFriendlyPets", 1)
			else
				SetCVar("nameplateShowFriendlyPets", 0)
			end
			if db.visPvecombatFriendGuardian then
				SetCVar("nameplateShowFriendlyGuardians", 1)
			else
				SetCVar("nameplateShowFriendlyGuardians", 0)
			end
			if db.visPvecombatFriendTotem then
				SetCVar("nameplateShowFriendlyTotems", 1)
			else
				SetCVar("nameplateShowFriendlyTotems", 0)
			end
			
			--PVE OUT OF COMBAT - ENEMY
			if db.visPvecombatEnemyUnit then
				SetCVar("nameplateShowEnemies", 1)
			else
				SetCVar("nameplateShowEnemies", 0)
			end
			if db.visPvecombatEnemyPet then
				SetCVar("nameplateShowEnemyPets", 1)
			else
				SetCVar("nameplateShowEnemyPets", 0)
			end
			if db.visPvecombatEnemyGuardian then
				SetCVar("nameplateShowEnemyGuardians", 1)
			else
				SetCVar("nameplateShowEnemyGuardians", 0)
			end
			if db.visPvecombatEnemyTotem then
				SetCVar("nameplateShowEnemyTotems", 1)
			else
				SetCVar("nameplateShowEnemyTotems", 0)
			end

			--PVP
		elseif isInPvp then
			

			--PVP - FRIEND
			if db.visPvpFriendUnit then
				SetCVar("nameplateShowFriends", 1)
			else
				SetCVar("nameplateShowFriends", 0)
			end
			if db.visPvpFriendPet then
				SetCVar("nameplateShowFriendlyPets", 1)
			else
				SetCVar("nameplateShowFriendlyPets", 0)
			end
			if db.visPvpFriendGuardian then
				SetCVar("nameplateShowFriendlyGuardians", 1)
			else
				SetCVar("nameplateShowFriendlyGuardians", 0)
			end
			if db.visPvpFriendTotem then
				SetCVar("nameplateShowFriendlyTotems", 1)
			else
				SetCVar("nameplateShowFriendlyTotems", 0)
			end
			
			--PVP - ENEMY
			if db.visPvpEnemyUnit then
				SetCVar("nameplateShowEnemies", 1)
			else
				SetCVar("nameplateShowEnemies", 0)
			end
			if db.visPvpEnemyPet then
				SetCVar("nameplateShowEnemyPets", 1)
			else
				SetCVar("nameplateShowEnemyPets", 0)
			end
			if db.visPvpEnemyGuardian then
				SetCVar("nameplateShowEnemyGuardians", 1)
			else
				SetCVar("nameplateShowEnemyGuardians", 0)
			end
			if db.visPvpEnemyTotem then
				SetCVar("nameplateShowEnemyTotems", 1)
			else
				SetCVar("nameplateShowEnemyTotems", 0)
			end
		end
	end
	addon.setVisibility = setVisibility

	local function softReset() -- Just deletes some savedData values to cause a refresh when setDoUpdate
		for i=1,#frames do
			frames[i].np.savedData.maxHealthIs = nil
			frames[i].np.savedData.levelIs = nil
		end
		
		setDoUpdate(1)
	end

	--UPDATES (u)
	function addon:uNameplate(option) 
		local np = self.np
		local d = np.d
		local savedData = np.savedData
		time = GetTime()
		
		if option=="onlyHp" then
			u.hp(np, "onlyHp")
			u.color(np, "onlyHp")
			
			if np.uCounterHp then np.uCounterHp = np.uCounterHp+1 end
			u.debug(np)
		elseif option=="onlyThreat" then
			u.threat(np, "onlyThreat")
			u.color(np, "onlyThreat")
			
			if np.uCounterThreat then np.uCounterThreat = np.uCounterThreat+1 end
			u.debug(np)
		elseif option=="onlyCast" then
			u.cast(np, "onlyCast")
			
			if np.uCounterCast then np.uCounterCast = np.uCounterCast+1 end
			u.debug(np)
		elseif option=="onlyAura" then
			u.auras(np)
			
			if np.uCounterAura then np.uCounterAura = np.uCounterAura+1 end
			u.debug(np)
		else
			u.collectDynamicData(np)
			
			if global.nameplateHider[d.nameIs] then
				np:Hide()
				
				return
			else
			
			
				np:Show()
			end
			
			d.alphaIs = np.alpha
			d.isTarget = playerTarget and d.alphaIs==1
			if d.isTarget then d.GUID = playerTargetGUID end
			
			unitIsDifferent = false
			-- Check if the unit has changed
			for index,value in pairs(d) do
				if index~="healthIs" and savedData[index]~=value then--
					unitIsDifferent = true
					
					break
				end
			end
			
			u.highlight(np)
			u.alpha(np)
			u.size(self)
			u.mouseover(np)
			u.MouseoverAlpha(np)
			u.unknownIcon(np)
			u.threat(np)
			u.name(np)
			u.tot(np)
			u.guild(np)
			u.hp(np)
			u.level(np)
			u.cast(np)
			u.targetNHL(np)
			u.targetNHL2(np)
			u.targetIcon(np)
			u.socialIcon(np)
			u.raidIcon(np)
			u.classIcon(np)
			u.roleIcon(np)
			u.totemIcon(np)
			u.auras(np)
			u.color(np)
			
			--SAVE DATA (d)
			for index,value in pairs(d) do
				savedData[index] = value
			end
			
			if np.uCounter then np.uCounter = np.uCounter+1 end
			u.debug(np, self)
		end
	end
	local uNameplate = addon.uNameplate

	function addon.uNameplateByIndex(index)
		uNameplate(frames[i])
	end
	local uNameplateByIndex = addon.uNameplateByIndex

	function addon.uNameplateByName(name)
		for index,value in pairs(framesShown) do
			if name==value.np.d.nameIs then
				uNameplate(value)
			end
		end
	end
	local uNameplateByName = addon.uNameplateByName
	u.auras = function() end

	function addon.uNameplateByRaidIcon(index, GUID)
		if not index or not GUID then return end
		
		for i,v in pairs(framesShown) do
			if index==v.np.d.hasRaidIcon then
				v.np.d.GUID = GUID
				uNameplate(v)
				
				return
			end
		end
	end
	local uNameplateByRaidIcon = addon.uNameplateByRaidIcon

	function addon.uNameplateByGUID(GUID, option) -- Options: "onlyAura"
		for index,value in pairs(framesShown) do
			if GUID and value.np.d.GUID and GUID==value.np.d.GUID then
				uNameplate(value, option)

				return
			end
		end
	end
	local uNameplateByGUID = addon.uNameplateByGUID

	--ON SHOW
	function addon:onShowNameplate() 
		local np = self.np
		local d = np.d
		local savedData = np.savedData
		time = GetTime()
		
		u.collectFixedData(np)
		u.collectDynamicData(np)
		
		if global.nameplateHider[d.nameIs] then
			np:Hide()
			
			return
		else
			np:Show()
		end
		
		d.isCasting = false
		np.cast:Hide()
		if playerTarget then
			np.alpha = db.alpha 
		else
			np.alpha = self:GetAlpha()
		end
		d.alphaIs = np.alpha
		d.isTarget = false
		
		np:SetFrameLevel(11)
		self.width = np.originalWidth
		self.height = np.originalHeight

		
		np.uCounter = 0
		np.uCounterAura = 0
		np.uCounterCast = 0
		np.uCounterHp = 0
		np.uCounterThreat = 0
		
		framesShown[self] = self
		
		unitIsDifferent = true
		
		u.highlight(np)
		u.alpha(np)
	--	u.size(self) --unremmed 28-06-14
		u.mouseover(np)
		u.MouseoverAlpha(np)
		u.unknownIcon(np)
		u.threat(np)
		u.name(np)
		u.tot(np)
		u.guild(np)
		u.hp(np)
		u.level(np)
		u.cast(np)
		u.targetNHL(np)
		u.targetNHL2(np)
		u.targetIcon(np)
		u.socialIcon(np)
		u.raidIcon(np)
		u.classIcon(np)
		u.roleIcon(np)
		u.totemIcon(np)
		u.threat(np)
		u.auras(np)
		u.debug(np)
		
	--	uNameplate(self) -- Update right now or you can see the frame change. --unremmed 28-06-14
		setDoUpdateMe(self, "frame")
	end

	--ON HIDE
	local onHideNameplate = addon.onHideNameplate

	function addon:onHideNameplate() 
		local np = self.np
		
		wipe(np.d)
		wipe(np.savedData)
		
		framesShown[self] = nil
		
		np.highlight:Hide()
		np.cast:Hide()
	end
	local onHideNameplate = addon.onHideNameplate
	--[[ Helper functions ]]
	local function formatTime(time)
		if time>60 then
			time = floor(time/60).."m"
		elseif time>=3 then
			time = floor(time)
		else
			time = resources.round(time, 1)
		end
		
		return time
	end

	local function getRaidIconIndex(raidIcon)
		-- ULx, ULy, LLx, LLy, URx, URy, LRx, LRy
		-- "Interface\\TargetingFrame\\UI-RaidTargetingIcons"
		if not raidIcon:IsShown() then return nil end
		
		local ULx,ULy,LLx,LLy,URx,URy,LRx,LRy = raidIcon:GetTexCoord() 
		
		for i=1,8 do
			if resources.raidIconTextureCoords[i][1]==ULx and
				resources.raidIconTextureCoords[i][2]==ULy and
					resources.raidIconTextureCoords[i][3]==LLx and
						resources.raidIconTextureCoords[i][4]==LLy and
							resources.raidIconTextureCoords[i][5]==URx and
								resources.raidIconTextureCoords[i][6]==URy and
									resources.raidIconTextureCoords[i][7]==LRx and
										resources.raidIconTextureCoords[i][8]==LRy then
											return i
										end
		end 
		
		return nil
	end


	--REACTION AND TYPE (reactionAndType: Determines the reaction, and type of unit from the health bar color)
		local function reactionAndType(red, green, blue)
			if red < .01 then 	-- Friendly
				if blue < .01 and green > .99 then return "FRIENDLY", "NPC"
				elseif blue > .99 and green < .01 then return "FRIENDLY", "PLAYER"
				end
			elseif red > .99 then
				if blue < .01 and green > .99 then return "NEUTRAL", "NPC"
				elseif blue < .01 and green < .01 then return "HOSTILE", "NPC"
				end
			elseif red > .5 and red < .6 then
				if green > .5 and green < .6 and blue > .5 and blue < .6 then return "TAPPED", "NPC" end 	-- .533, .533, .99	-- Tapped Mob
			end
			return "HOSTILE", "PLAYER"
		end



	local function getUnitCombatStatus(r, g, b)
		return r>.5 and g<.5
	end

	local function threatByColor(threatGlow)
		local redCan, greenCan, blueCan, alphaCan = threatGlow:GetVertexColor()
		if not threatGlow:IsShown() then return "LOW" end
		if greenCan > .7 then return "MEDIUM" end
		if redCan > .7 then return "HIGH" end
	end

	--ROLE ("TANK" "HEALER" "DAMAGER")
	local function getRole(d)  
		
		if not d.nameIs then return nil end
		
		local name = strlower(d.nameIs)
		
		if d.reaction=="HOSTILE" and d.type~="PLAYER" and d.isCasting and d.castingName and (not global.casterList[name] or not global.healerList[name]) then
			local castName = strlower(d.castingName)
			
			for i=1,#db.healingSpells do
				if strfind(castName,db.healingSpells[i]) then
					global.healerList[name] = true
					break
				end
			end
			
			global.casterList[name] = true
		end
		
		if global.healerList[name] then
			return "HEALER"
		elseif global.casterList[name] then
			return "DAMAGER"
		elseif false then
			return "TANK"
		else
			return nil
		end
	end

	local function colorToString(r,g,b)
		return "C"..math.floor((100*r) + 0.5)..math.floor((100*g) + 0.5)..math.floor((100*b) + 0.5)
	end
	local classByColor = {}
	for classname,color in pairs(RAID_CLASS_COLORS) do 
		classByColor[colorToString(color.r, color.g, color.b)] = classname
	end
	local function getClassAndRole(d)
		local c, r
		
		if isInInstance~="none" and d.type~="PLAYER" and d.reaction=="HOSTILE" then c, r = resources.factionChampClassAndRole(d.nameIs) end
		
		if d.type=="PLAYER" and d.reaction=="HOSTILE" then
			c = classByColor[colorToString(d.red, d.green, d.blue)] or nil
		elseif d.type=="PLAYER" and d.class then
			c = d.class
		end
		
		if not r and d.reaction=="HOSTILE" then
			if d.isBoss then
				r = "BOSS"
			else
				r = getRole(d) or nil
			end
		end
		
		return c, r
	end

	local function getTotem(name)
		for i=1,#resources.totems do
			if strfind(name, resources.totems[i].name) then
				return resources.totems[i].tex
			end
		end
		
		return nil
	end

	local function filterName(name)
		name = strlower(name)
		for i=1,#db.nameplateHider do
			if name==db.nameplateHider[i] then
				return true
			end
		end
		
		return false
	end
--[[
----------
--guildName, guildRankName, guildRankIndex = GetGuildInfo(unit);
 local status = true
   if IsInGuild()
   then
       local test = GetGuildInfo("player")
       if (test == nil)
       then
           status = false 
       end
   end
   
   return status
   -----------------]]
	local function collectUnitInfo(unit)
		if not UnitExists(unit) then return end
		
		local GUID = UnitGUID(unit)
		local name, rlm = UnitName(unit)
		local _, class = UnitClass(unit)
		local  guildName = GetGuildInfo(unit)
		local isPlayer = UnitIsPlayer(unit)
		-- if guildName = UnitIsInMyGuild (unit) then self.guild = guildName  end --sqw trial
		if not name or name==UNKNOWN then return end
		
		if isPlayer and not rlm then
			playerList[name] = GUID
			playerList[GUID] = addon:Serialize(name, GUID, class, guildName or "NONE", rlm or realmName)
		end
		
		if isPlayer then
			temporaryList[name] = GUID
			temporaryList[GUID] = addon:Serialize(name, GUID, class or nil, guildName or "NONE", rlm or realmName or "NONE")
		end
		
		if UnitClassification(unit)=="worldboss" then
			temporaryList[name] = GUID
			temporaryList[GUID] = addon:Serialize(name, GUID, class or nil, guildName or "NONE", rlm or realmName or "NONE")
		end
	end

	local function checkHealthbarNotVisible(d)
		if isInSanctuary or d.isTotem then
			return true
		elseif isInPve then
			if inCombat then
				if (not db.healthBarFriendPveCombat and d.layout=="FRIEND") or (not db.healthBarEnemyPveCombat and d.layout=="ENEMY") then
					return true
				end
			else
				if (not db.healthBarFriendPve and d.layout=="FRIEND") or (not db.healthBarEnemyPve and d.layout=="ENEMY") then
					return true
				end
			end
		elseif isInPvp then
			if (not db.healthBarFriendPvp and d.layout=="FRIEND") or (not db.healthBarEnemyPvp and d.layout=="ENEMY") then
				return true
			end
		end
		
		return false
	end

	local function checkCastbarNotVisible(d)
		if d.isTotem then
			return true
		elseif isInPve then
			if inCombat then
				if (not db.castBarFriendPveCombat and d.layout=="FRIEND") or (not db.castBarEnemyPveCombat and d.layout=="ENEMY") then
					return true
				end
			else
				if (not db.castBarFriendPve and d.layout=="FRIEND") or (not db.castBarEnemyPve and d.layout=="ENEMY") then
					return true
				end
			end
		elseif isInPvp then
			if (not db.castBarFriendPvp and d.layout=="FRIEND") or (not db.castBarEnemyPvp and d.layout=="ENEMY") then
				return true
			end
		end
		
		return false
	end

	local function checkBuffsNotVisible(d)
		if d.isTotem then
			return true
		elseif isInPve then
			if inCombat then
				if (not db.buffsFriendPveCombat and d.layout=="FRIEND") or (not db.buffsEnemyPveCombat and d.layout=="ENEMY") then
					return true
				end
			else
				if (not db.buffsFriendPve and d.layout=="FRIEND") or (not db.buffsEnemyPve and d.layout=="ENEMY") then
					return true
				end
			end
		elseif isInPvp then
			if (not db.buffsFriendPvp and d.layout=="FRIEND") or (not db.buffsEnemyPvp and d.layout=="ENEMY") then
				return true
			end
		else
			return false
		end
	end

	local function isNPCGrey(level)
		--local r, g, b = unpack(resources.getLevelColor(level, playerLevel))
		--return r==0.5 and g==0.5 and b==0.5 --GREY LOW LEVEL HEALTH BAR
		-- return r==1 and g==0 and b==0 --RED LOW LEVEL HEALTH BAR
		return isInPvp --fool into creating normal enemy/friendly colors ** prefer this
	end

	local function checkTankMode()
		if playerClass=="DEATHKNIGHT" then
			tankMode = UnitBuff("player", GetSpellInfo(48263)) or false		-- Blood Presence
		elseif playerClass=="PALADIN" then
			tankMode = UnitBuff("player", GetSpellInfo(25780)) or false	 -- Righteous Fury
		elseif playerClass=="WARRIOR" then
			tankMode = GetShapeshiftForm()==2 or false -- Defensive Stance 
		elseif playerClass=="DRUID" then
			tankMode = GetShapeshiftForm()==1 or false -- Bear/Dire Bear Form 
		else
			tankMode = false
		end
	end

	-- Modify and update elements
	function u:collectFixedData()
		local d = self.d
		local savedData = self.savedData
		
		-- Fixed data
		d.nameIs = self.regions.spelltext:GetText()
		local crz = gsub(d.nameIs, " %(%*%)", "")	--strip crx (*) added in 5.4
		d.nameIs=crz								--strip crx (*) added in 5.4
		d.nameIsReplacement = global.nameReplacer[d.nameIs] or nil
		d.isBoss = self.regions.skullicon:IsShown()
		d.isElite = self.regions.eliteicon:IsShown()
		d.isTotem = getTotem(d.nameIs)
	end

	function u:collectDynamicData()
		local d = self.d
		local savedData = self.savedData
		
		-- Dynamic d
		_, d.maxHealthIs = self.children.healthBar:GetMinMaxValues()
		d.healthIs = self.children.healthBar:GetValue()
		d.levelIs = tonumber(self.regions.level:GetText()) or 999
		d.isInCombat = getUnitCombatStatus(self.regions.spelltext:GetTextColor())
		d.hasRaidIcon = getRaidIconIndex(self.regions.raidIcon)
		d.raidIcon = self.regions.raidIcon
		if inCombat then d.threatState = threatByColor(self.regions.threatglow) else d.threatState = "LOW" end
		
		if temporaryList[d.nameIs] then
			d.GUID = temporaryList[d.nameIs]
			
			local success, _, _, class, guild, _ = addon:Deserialize(temporaryList[d.GUID])
			if success then
				d.class = class
				d.guild = guild
			end
		elseif playerList[d.nameIs] then
			d.GUID = playerList[d.nameIs]
			
			local success, _, _, class, guild, _ = addon:Deserialize(playerList[d.GUID])
			if success then
				d.class = class
				d.guild = guild
			end
		else
			if not inCombat and d.type~="PLAYER" and global.npcList[d.nameIs] then
				d.guild = global.npcList[d.nameIs]
			else
				d.guild = nil
			end
		end
		
		d.red, d.green, d.blue = self.children.healthBar:GetStatusBarColor()
		d.reaction, d.type = reactionAndType(d.red, d.green, d.blue, d)
		if not inCombat and isInSanctuary and d.reaction=="HOSTILE" then d.reaction = "FRIENDLY" end
		d.class, d.role = getClassAndRole(d)
		
		if d.reaction=="FRIENDLY" then d.layout = "FRIEND"
		elseif d.reaction=="NEUTRAL" then if global.agressiveList[d.nameIs] then d.layout = "ENEMY"       
		else d.layout = "FRIEND"
		end
		else
			d.layout = "ENEMY"
		end
		
		d.healthNotVisible = checkHealthbarNotVisible(d)
		
		d.isCasting = self.children.castBar:IsShown()
		if d.isCasting then
			d.iscastingUninterruptable = self.regions.castNostop:IsShown()
			d.castIconTexture = self.regions.spellIcon:GetTexture()
			_, d.castingMax = self.children.castBar:GetMinMaxValues()
			d.castingTime = self.children.castBar:GetValue()
			d.castingName = UnitCastingInfo("target") or UnitChannelInfo("target")
		end
		
		if inCombat and d.reaction=="NEUTRAL" and d.isInCombat and d.healthIs<d.maxHealthIs then -- Turn neutral target into agressive
			if not global.agressiveList[d.nameIs] then global.agressiveList[d.nameIs] = true end
		end
		
		d.isMouseover = self.highlight:IsShown()
		if d.isMouseover then d.GUID = UnitGUID("mouseover")  end
	end

	-- COLORS
	function u:color(option)
		if option=="onlyHp" then

			--return --TODO
		end
		
		if option=="onlyThreat" then
			--return
		end
		
		local namer, nameg, nameb, guildr, guildg, guildb, hpr, hpg, hpb
		
		if isInPvp then
			if db.healthBarColorPvP then
				if self.d.layout=="FRIEND" then
					if self.d.class then
						namer, nameg, nameb = RAID_CLASS_COLORS[self.d.class].r, RAID_CLASS_COLORS[self.d.class].g, RAID_CLASS_COLORS[self.d.class].b
					else
						namer, nameg, nameb = 0/255, 174/255, 239/255
						
					end
					hpNumberr, hpNumberg, hpNumberb = 0/255, 174/255, 239/255
				else
					if self.d.class then
						namer, nameg, nameb = RAID_CLASS_COLORS[self.d.class].r, RAID_CLASS_COLORS[self.d.class].g, RAID_CLASS_COLORS[self.d.class].b
					else
						namer, nameg, nameb = 255/255, 0/255, 0/255
					end
					hpNumberr, hpNumberg, hpNumberb = 255/255, 0/255, 0/255
				end
			elseif self.d.class then
				namer, nameg, nameb = RAID_CLASS_COLORS[self.d.class].r, RAID_CLASS_COLORS[self.d.class].g, RAID_CLASS_COLORS[self.d.class].b
				hpNumberr, hpNumberg, hpNumberb = RAID_CLASS_COLORS[self.d.class].r, RAID_CLASS_COLORS[self.d.class].g, RAID_CLASS_COLORS[self.d.class].b
			else
				namer, nameg, nameb = resources.darkenColor(self.d.red, self.d.green, self.d.blue)
				hpNumberr, hpNumberg, hpNumberb = resources.darkenColor(self.d.red, self.d.green, self.d.blue)
			end
			
		
		else
			if self.d.type=="PLAYER" or self.d.class then -- "PLAYER"
				if self.d.class then
					namer, nameg, nameb = RAID_CLASS_COLORS[self.d.class].r, RAID_CLASS_COLORS[self.d.class].g, RAID_CLASS_COLORS[self.d.class].b
					if raid[self.d.nameIs] then guildr, guildg, guildb = resources.getSocialColor("raid")
					elseif party[self.d.nameIs] then guildr, guildg, guildb = resources.getSocialColor("party")
					elseif guild[self.d.nameIs] then guildr, guildg, guildb = resources.getSocialColor("guild")
					elseif bnet[self.d.nameIs] then guildr, guildg, guildb = resources.getSocialColor("bnet")
					elseif friend[self.d.nameIs] then guildr, guildg, guildb = resources.getSocialColor("friend")
					else guildr, guildg, guildb = 153/255, 153/255, 255/255--[[guildr, guildg, guildb = resources.lightenColor(self.d.red, self.d.green, self.d.blue)]] end
					hpNumberr, hpNumberg, hpNumberb = RAID_CLASS_COLORS[self.d.class].r, RAID_CLASS_COLORS[self.d.class].g, RAID_CLASS_COLORS[self.d.class].b
				elseif raid[self.d.nameIs] then
					namer, nameg, nameb = resources.getSocialColor("raid")
					guildr, guildg, guildb = resources.getSocialColor("raid")
					hpNumberr, hpNumberg, hpNumberb = resources.lightenColor(self.d.red, self.d.green, self.d.blue)
				elseif party[self.d.nameIs] then
					namer, nameg, nameb = resources.getSocialColor("party")
					guildr, guildg, guildb = resources.getSocialColor("party")
					hpNumberr, hpNumberg, hpNumberb = resources.lightenColor(self.d.red, self.d.green, self.d.blue)
				elseif guild[self.d.nameIs] then
					namer, nameg, nameb = resources.getSocialColor("guild")
					guildr, guildg, guildb = resources.getSocialColor("guild")
					hpNumberr, hpNumberg, hpNumberb = resources.lightenColor(self.d.red, self.d.green, self.d.blue)
				elseif bnet[self.d.nameIs] then
					namer, nameg, nameb = resources.getSocialColor("bnet")
					guildr, guildg, guildb = resources.getSocialColor("bnet")
					hpNumberr, hpNumberg, hpNumberb = resources.lightenColor(self.d.red, self.d.green, self.d.blue)
				elseif friend[self.d.nameIs] then
					namer, nameg, nameb = resources.getSocialColor("friend")
					guildr, guildg, guildb = resources.getSocialColor("friend")
					
					hpNumberr, hpNumberg, hpNumberb = resources.lightenColor(self.d.red, self.d.green, self.d.blue)
				else
				---------------------------------------------------
				namer, nameg, nameb = 153/255, 153/255, 255/255 --this controls umknown color
				guildr, guildg, guildb = 153/255, 153/255, 255/255
				-----------------------------------------------------
hpNumberr, hpNumberg, hpNumberb = resources.lightenColor(self.d.red, self.d.green, self.d.blue)
				-- namer, nameg, nameb = resources.lightenColor(self.d.red, self.d.green, self.d.blue) --orig
					--guildr, guildg, guildb = resources.lightenGuildColor(self.d.red, self.d.green, self.d.blue) --sqw
					--guildr, guildg, guildb = resources.lightenColor(self.d.red, self.d.green, self.d.blue) --orig
					
					
				end
			elseif self.d.type~="PLAYER" and self.d.layout=="FRIEND" then -- "FRIEND"
				namer, nameg, nameb = resources.darkenColor(self.d.red, self.d.green, self.d.blue)
				--guildr, guildg, guildb = resources.darkenColor(self.d.red, self.d.green, self.d.blue)
			  
			  -- guildr, guildg, guildb = resources.darkenColor(self.d.red*.80, self.d.green*.80, self.d.blue*.80)
	guildr, guildg, guildb = resources.lightenColor(self.d.red, self.d.green, self.d.blue) --orig
				hpNumberr, hpNumberg, hpNumberb = resources.darkenColor(self.d.red, self.d.green, self.d.blue)
			else
				if not inCombat or not db.threatEnabled or self.d.threatState==0 then -- "ENEMY"
					if self.d.levelIs and isNPCGrey(self.d.levelIs) then -- Lowlvl
						namer, nameg, nameb = unpack(resources.getLevelColor(self.d.levelIs, playerLevel))
						guildr, guildg, guildb = unpack(resources.getLevelColor(self.d.levelIs, playerLevel))
						hpNumberr, hpNumberg, hpNumberb = resources.darkenColor(unpack(resources.getLevelColor(self.d.levelIs, playerLevel)))
					else -- Normal color - SET GREY TO RED but also changes neutrals to red??
					
						namer, nameg, nameb = resources.lightenColor(self.d.red, self.d.green, self.d.blue)
						--guildr, guildg, guildb = resources.lightenColor(self.d.red, self.d.green, self.d.blue)
						 guildr, guildg, guildb = resources.lightenGuildColor(self.d.red, self.d.green, self.d.blue)
						 
						-- hpNumberr, hpNumberg, hpNumberb = db.HBNumberColorCustom.r,db.HBNumberColorCustom.g,db.HBNumberColorCustom.b -- will show health number based on own color defined in options
						 
						hpNumberr, hpNumberg, hpNumberb = resources.darkenColor(self.d.red, self.d.green, self.d.blue)
						--hpNumberr, hpNumberg, hpNumberb = resources.lightenColor(self.d.red, self.d.green, self.d.blue)
					end
				else -- Threat coloring
					local perc = self.d.threatPercent
					
					if perc then
						local r, g, b
						
						if self.d.threatIsTanked then
							r, g, b = db.colorThreatTanked.r,db.colorThreatTanked.g,db.colorThreatTanked.b
						elseif perc<60 then
							r, g, b = db.colorThreatVerySafe.r,db.colorThreatVerySafe.g,db.colorThreatVerySafe.b
						elseif perc<80 then
							r, g, b = resources.colorGradient((perc-60)/20/100, db.colorThreatSafe, db.colorThreatUnsafe)
							--self.tot:SetText(tostring(round((perc-60)/20/100,2))..", "..tostring(perc))
						elseif perc<100 then
							r, g, b = resources.colorGradient((perc-80)/20/100, db.colorThreatUnsafe, db.colorThreatAlert)
							--self.tot:SetText(tostring(round((perc-80)/20/100,2))..", "..tostring(perc))
						else
							r, g, b = db.colorThreatAlert.r,db.colorThreatAlert.g,db.colorThreatAlert.b
						end
						namer, nameg, nameb = resources.lightenColor(r,g,b) 
						
						hpNumberr, hpNumberg, hpNumberb = r, g, b
					else -- or normal color
						namer, nameg, nameb = self.d.red, self.d.green, self.d.blue
					   -- namer, nameg, nameb = resources.lightenColor(self.d.red, self.d.green, self.d.blue)
						guildr, guildg, guildb = resources.lightenGuildColor(self.d.red, self.d.green, self.d.blue)
						hpNumberr, hpNumberg, hpNumberb = self.d.red, self.d.green, self.d.blue
					end
				end
			end
		end
		
		if self.name.r~=namer or self.name.g~=nameg or self.name.b~=nameb then
			self.name:SetTextColor(namer, nameg, nameb)
			self.name.r = namer
			self.name.g = namer
			self.name.b = namer
		end
		if self.guild.r~=guildr or self.guild.g~=guildg or self.guild.b~=guildb then
			self.guild:SetTextColor(guildr, guildg, guildb)
			self.guild.r = guildr
			self.guild.g = guildr
			self.guild.b = guildr
		end
		if not self.d.healthNotVisible and (self.hpNumber.r~=hpNumberr or self.hpNumber.g~=hpNumberg or self.hpNumber.b~=hpNumberb) then
			if db.showHpBar then
				if db.healthBarColorCustom then
					self.hp:SetStatusBarColor(db.customColor.r,db.customColor.g,db.customColor.b)
				else
					self.hp:SetStatusBarColor(hpNumberr, hpNumberg, hpNumberb)

					--HP [IF CAST BAR SHOWN] COLOR CONTROL - START -->>
					if db.healthBarNumberColorCustom then
					hpNumberr, hpNumberg, hpNumberb = db.HBNumberColorCustom.r,db.HBNumberColorCustom.g,db.HBNumberColorCustom.b
					else
					--Default class/threat
					end
					--hpNumberr, hpNumberg, hpNumberb = 1, 1, 1 --SET HP VALUE TO COLOR WHITE **sqw added THIS IS WHERE TO CONTROL/ADD CUSTOM COLOR CONTROL IF CASTBAR SHOWN (NO CAST BAR THEN COLOUR IS RED/CLASS)




					--HP [IF CAST BAR SHOWN] COLOR CONTROL - END <<--
				end
			end
			self.hpNumber:SetTextColor(hpNumberr, hpNumberg, hpNumberb)
			self.hpNumber.r = hpNumberr
			self.hpNumber.g = hpNumberr
			self.hpNumber.b = hpNumberr
		end
	end
	function u:name()
		if self.d.isTotem then
			if self.name.value~=nil then
				self.name:SetText(nil)
				self.name.value = nil
			end
			
			return
		end
		
		local text = self.d.nameIsReplacement or self.d.nameIs
		
		if self.name.value~=text then
			self.name:SetText(text)
			self.name.value = text
		end
		
		if (isInPvp and self.d.layout=="ENEMY") or self.d.isBoss then
			if self.name.font~=db.fontb then
				self.name:SetFont(LSM:Fetch("font", db.fontb), db.fontsizeName, db.outline)
				self.name.font = db.fontb
			end
		else
			if self.name.font~=db.font then
				self.name:SetFont(LSM:Fetch("font", db.font), db.fontsizeName, db.outline)
				self.name.font = db.font
			end
		end
	end

	function u:tot()
		if not db.tot then return end
		
		if not self.d.tot or self.d.isTotem or not isInArena then
			if self.tot.value~=nil then
				self.tot:SetText(nil)
				self.tot.value = nil
			end
			
			return
		end
		
		local text = "["..self.d.tot.."]"
		
		if self.tot.value~=text then
			self.tot:SetText(text)
			self.tot.value = text
		end
		
		local r, g, b
		if self.d.totClass then
			r, g, b = RAID_CLASS_COLORS[self.d.totClass].r, RAID_CLASS_COLORS[self.d.totClass].g, RAID_CLASS_COLORS[self.d.totClass].b
		else
			r, g, b = 1, 0, 0
			--r, g, b = 0.5, 0.5, 0.5
		end
		if self.tot.r~=r or self.tot.g~=g or self.tot.b~=b then
			self.tot:SetTextColor(r, g, b)
			self.tot.r = r
			self.tot.r = g
			self.tot.r = b
		end
	end

	function u:guild()
		if not db.guildName or self.d.isTotem or inCombat or isInPvp or self.d.layout=="ENEMY" or not self.d.healthNotVisible or not self.d.guild or self.d.guild=="NONE" or (isInInstance~="none" and self.d.type=="PLAYER") then
			if self.guild.value~=nil then
				self.guild:SetText(nil)
				self.guild.value = nil
			end
			
			return
		end
		
		local text = "<"..self.d.guild..">"
		
		if self.guild.value~=text then
			self.guild:SetText(text)
			self.guild.value = text
		end

	end

	function u:targetNHL()
		if not db.targetNHL 
			then
				if self.targetNHL.visible then
					self.targetNHL:Hide()
					self.targetNHL.visible = false
				end
				return
			end
		if self.d.isTarget  then 	
			if not self.targetNHL.visible then
				self.targetNHL:Show()
				self.targetNHL.visible = true
			end
			return
		end
		if self.targetNHL.visible then
			self.targetNHL:Hide()
			self.targetNHL.visible = false
		end
		return

	end

	function u:targetNHL2()
		if not db.targetNHL2 
			then
				if self.targetNHL2.visible then
					self.targetNHL2:Hide()
					self.targetNHL2.visible = false
				end
				return
			end
		if self.d.isTarget  then 	
			if not self.targetNHL2.visible or self.d.hasRaidIcon then
				self.targetNHL2:Show()
				self.targetNHL2.visible = true
			end
			return
		end
		if self.targetNHL2.visible then
			self.targetNHL2:Hide()
			self.targetNHL2.visible = false
		end
		return

	end

	function u:targetIcon()
		if not db.targetIcon 
			then
				if self.targetIcon.visible then
					self.targetIcon:Hide()
					self.targetIcon.visible = false
				end
				return
			end
		if self.d.isTarget  then 	
			if not self.targetIcon.visible then
				self.targetIcon:Show()
				self.targetIcon.visible = true
			end
			return
		end
		if self.targetIcon.visible then
			self.targetIcon:Hide()
			self.targetIcon.visible = false
		end
		return

	end


	function u:socialIcon()
		if not db.socialIcon or self.d.hasRaidIcon or self.d.isTotem or inCombat or isInPvp or isInInstance~="none" or self.d.layout=="ENEMY" or not self.d.class then
			if self.socialIcon.visible then
				self.socialIcon:Hide()
				self.socialIcon.visible = false
			end
			
			return
		end
		
		local r, g, b
		if raid[self.d.nameIs]			then r, g, b = resources.getSocialColor("raid")
		elseif party[self.d.nameIs]		then r, g, b = resources.getSocialColor("party")
		elseif guild[self.d.nameIs]		then r, g, b = resources.getSocialColor("guild")
		elseif bnet[self.d.nameIs]		then r, g, b = resources.getSocialColor("bnet")
		elseif friend[self.d.nameIs]	then r, g, b = resources.getSocialColor("friend")
		else
			if self.socialIcon.visible then
				self.socialIcon:Hide()
				self.socialIcon.visible = false
			end
			
			return
		end
		
		if not self.socialIcon.visible then
			self.socialIcon:Show()
			self.socialIcon.visible = true
			if self.socialIcon.r~=r or self.socialIcon.g~=g or self.socialIcon.b~=b then
				self.socialIcon:SetVertexColor(r, g, b)
				self.socialIcon.r = r
				self.socialIcon.g = g
				self.socialIcon.b = b
			end
		end
	end

	function u:hp(option)
		local text
		
		if option=="onlyHp" and not self.d.healthNotVisible then
			local healthIs = self.children.healthBar:GetValue()
			local _, maxHealthIs = self.children.healthBar:GetMinMaxValues()
			
			if db.showHpPercent then
				local perc = min((healthIs/maxHealthIs)*100, 100)
				
				if perc<1 or self.d.isBoss then
				local d=(healthIs/maxHealthIs)*100
				text=math.floor(d+.5)
					--text = resources.round((healthIs/maxHealthIs)*100, 1)
				else
					text = floor((healthIs/maxHealthIs)*100)
				end
			else

				text = resources.siValue(healthIs)
			end
			
			if db.showHpBar and self.hp.value~=healthIs then
				self.hp:SetValue(healthIs)
				self.hp.value = healthIs
			end
			if self.hpNumber.value~=text then
				self.hpNumber:SetText(text)
				self.hpNumber.value = text
			end
			
			return
		end
		
		if addon.configMode then
			self.d.healthIs = fastrandom(10, 90)
			self.d.maxHealthIs = 100
		end
		
		if self.d.healthNotVisible then
			if self.hp.visible then
				self.hp:Hide()
				self.hp.visible = false
			end
			
			if self.hpNumber.value~=nil then
				self.hpNumber:SetText(nil)
				self.hpNumber.value = nil
			end
			
			return
		end
		
		if db.showHpBar then
			if not self.hp.visible then
				self.hp:Show()
				self.hp.visible = true
			end
			
			if self.hpNumberBg.visible then
				self.hpNumberBg:Hide()
				self.hpNumberBg.visible = false
			end
		else
			if self.hp.visible then
				self.hp:Hide()
				self.hp.visible = false
			end
			
			if not self.hpNumberBg.visible then
				self.hpNumberBg:Show()
				self.hpNumberBg.visible = true
			end
		end
		
		if self.hp.max~=self.d.maxHealthIs then
			self.hp:SetMinMaxValues(0, self.d.maxHealthIs)
			self.hp.max = self.d.maxHealthIs
		end
		
		if db.showHpPercent then
			local perc = min((self.d.healthIs/self.d.maxHealthIs)*100, 100)
			
			if perc<1 or self.d.isBoss then
				--text = resources.round((self.d.healthIs/self.d.maxHealthIs)*100, 1)
				local d=(self.d.healthIs/self.d.maxHealthIs)*100
				text=math.floor(d+.5)
			else
				text = floor((self.d.healthIs/self.d.maxHealthIs)*100)
			end
		else
			text = resources.siValue(self.d.healthIs)
		end
		
		if db.showHpBar and self.hp.value~=self.d.healthIs then
			self.hp:SetValue(self.d.healthIs)
			self.hp.value = self.d.healthIs
		end
		
		if self.hpNumber.value~=text then
			self.hpNumber:SetText(text)
			self.hpNumber.value = text
		end
	end

	function u:level()
		if db.showLevel then
		
		if self.d.type=="PLAYER" or self.d.isBoss or self.d.isTotem or self.d.layout=="FRIEND" or isInInstance~="none" or isInPvp then
			if self.level.value~=nil then
				self.level:SetText(nil)
				self.level.value = nil
			end
			
			return
		end
		
		local text = self.d.levelIs
		if text and self.d.isElite then text = text.."+" end
		
		if self.level.value~=text then
			self.level:SetText(text)
			self.level.value = text
		end
		
		local r, g, b = unpack(resources.getLevelColor(self.d.levelIs, playerLevel))
		if self.level.r~=r or self.level.g~=g or self.level.b~=b then
			self.level:SetTextColor(r, g, b)
			self.level.r = r
			self.level.g = g
			self.level.b = b
		end
		else
		self.level:SetText(nil)
				self.level.value = nil
				end
	end

	function u:cast(option)
		if addon.configMode and self.d.layout~="FRIEND" then
			self.d.isCasting = true
			self.d.castingMax = 2
			self.d.castingTime = 1.1
			self.d.castingName = "Config Spell"
		end
		
		if self.d.GUID and guidCasts[self.d.GUID] then
			if guidCasts[self.d.GUID].isCasting and not checkCastbarNotVisible(self.d) then
				self.cast:SetMinMaxValues(0, guidCasts[self.d.GUID].max)
				self.cast:SetValue(guidCasts[self.d.GUID].value)
				self.cast.time:SetText(resources.round(guidCasts[self.d.GUID].value, 1))
				self.cast.text:SetText(guidCasts[self.d.GUID].name)
				self.cast.icon.tex2:SetTexture(guidCasts[self.d.GUID].icon or "Interface\\Icons\\Inv_misc_questionmark")
				
				if guidCasts[self.d.GUID].notInterruptible then
					self.cast:SetStatusBarColor(0.5,0.5,0.5,0.75)
				else
					self.cast:SetStatusBarColor(db.castColor.r,db.castColor.g,db.castColor.b,db.castColor.a)
				end
				
				self.cast.list = guidCasts[self.d.GUID]
				self.cast.lastUpdate = 0
				
				if not self.cast.visible then
					self.cast:Show()
					self.cast.visible = true
					if db.showHpBar then
						self.cast:SetPoint("TOP", self.hp, "BOTTOM", 0, -db.spacingFixed*2)
					else
						self.cast:SetPoint("TOP", self.hpNumber, "BOTTOM", 0, -db.spacingFixed*2)
					end
				end
			else
				guidCasts[self.d.GUID].isCasting = false
				
				self.cast.list = nil
				self.cast.lastUpdate = 0
				
				if self.cast.visible then
					self.cast:Hide()
					self.cast.visible = false
				end
			end
		end
	end

	--RAID ICON
	function u:raidIcon()
		if self.d.hasRaidIcon then
			if not self.raidIcon.visible then
				self.raidIcon:Show()			--if hide() then do not see raid icon above target
				self.raidIcon.visible = true    --if false & hide() above then do not see raid icon above target
			end
			
			self.raidIcon:SetTexCoord(self.d.raidIcon:GetTexCoord())
		else
			if self.raidIcon.visible then
				self.raidIcon:Hide()
				self.raidIcon.visible = false
			end
		end
	end

	--CLASS ICON
	function u:classIcon()
		if self.d.isTotem or self.d.layout=="FRIEND" or not db.classIcon or not self.d.class then
			if self.classIcon.visible then
				self.classIcon:Hide()
				self.classIcon.visible = false
			end
			
			return
		end
		
		if self.d.class then
			if not self.classIcon.visible then
				self.classIcon:Show()
				self.classIcon.visible = true
			end
			
			local coords = resources.classIcon[self.d.class]
			self.classIcon:SetTexCoord(coords[1], coords[2], coords[3], coords[4])
		end
	end

	--ROLE ICON
	function u:roleIcon()
		if not db.roleIcon or not self.d.role or self.d.isTotem or self.d.layout=="FRIEND" or self.d.type=="PLAYER" then
			if self.roleIcon.visible then
				self.roleIcon:Hide()
				self.roleIcon.visible = false
			end
			
			return
		end
		
		local role = resources.roleTextureCoords[self.d.role]
		
		if type(role)=="table" then
			if not self.roleIcon.visible then
				self.roleIcon:Show()
				self.roleIcon.visible = true
			end
			
			self.roleIcon:SetTexCoord(unpack(resources.roleTextureCoords[self.d.role]))
		else
			if self.roleIcon.visible then
				self.roleIcon:Hide()
				self.roleIcon.visible = false
			end
		end
	end

	--TOTEM ICON
	function u:totemIcon()
		if self.d.isTotem then
			if not self.totemIcon.visible then
				self.totemIcon:Show()
				self.totemIcon.visible = true
			end
			
			local text = self.d.isTotem
			if self.totemIcon.value~=text then
				self.totemIcon:SetTexture(text)
				self.totemIcon.value = text
			end
		else
			if self.totemIcon.visible then
				self.totemIcon:Hide()
				self.totemIcon.visible = false
			end
		end
	end

	--UNKNOWN ICON
	function u:unknownIcon()
		if not db.unknownIcon or self.d.isTotem or self.d.GUID or (self.d.type~="PLAYER" and self.d.layout=="FRIEND" and global.npcList[self.d.nameIs]) then
			if self.unknownIcon.visible then
				self.unknownIcon:Hide()
				self.unknownIcon.visible = false
			end
		else
			if not self.unknownIcon.visible then
				self.unknownIcon:Show()
				self.unknownIcon.visible = true
			end
		end
	end

	--THREAT
	function u:threat(option)
		if option=="onlyThreat" and db.threatEnabled then
			self.d.threatState = threatByColor(self.regions.threatGlow)
		end
		
		if addon.configMode and db.threatEnabled and self.d.layout~="FRIEND" then
			self.d.threatState = "HIGH"
		elseif not db.threatEnabled or not inCombat or self.d.class or self.d.isTotem or self.d.layout=="FRIEND" or (playerClass~="HUNTER" and not hasGroup) then
			self.d.threatState = 0
			
			return
		end
		
		if tankMode then
			if not self.d.threatState or self.d.threatState=="HIGH" then
				self.d.threatState = 1
			elseif self.d.threatState=="MEDIUM" then
				self.d.threatState = 2
			elseif self.d.threatState=="LOW" then
				self.d.threatState = 3
			end
		else
			if not self.d.threatState or self.d.threatState=="LOW" then
				self.d.threatState = 1
			elseif self.d.threatState=="MEDIUM" then
				self.d.threatState = 2
			elseif self.d.threatState=="HIGH" then
				self.d.threatState = 3
			end
		end
		
		local list = guidThreat[self.d.GUID]
		if list then
			if tankMode then
				if list.isTanked then
					self.d.threatIsTanked = true
				else
					self.d.threatIsTanked = false
					
					if list.player==100 or self.d.threatState==3 then
						self.d.threatPercent = 0
					else
						self.d.threatPercent = list.groupMember
					end
				end
			else
				if list.player==100 or self.d.threatState==3 then
					self.d.threatPercent = 100
				else
					self.d.threatPercent = list.player
				end
			end
			
			
		else
			if self.d.threatState==1 then
				self.d.threatPercent = 0
			elseif self.d.threatState==2 then
				self.d.threatPercent = 90
			elseif self.d.threatState==3 then
				self.d.threatPercent = 100
			end
			

		end
	end

	--SIZING
	function u:size() -- self = frame
		local width, height
		
		if inCombat then
			return
		elseif self.np.d.layout=="FRIEND" then
			width = self.np.originalWidth/3.8
			height = self.np.originalHeight/2
		else
			width = self.np.originalWidth
			height = self.np.originalHeight
			
		end
		
		if self.width~=width then
			self:SetWidth(width)
			self.width = width
		end
		if self.height~=height then
			self:SetHeight(height)
			self.height = height
		end
	end

	--HIGHLIGHT
	function u:highlight()
		

		if self.d.healthNotVisible then -- Highlight over name
			self.highlight:ClearAllPoints()
			self.highlight:SetAllPoints(self.name)
			--???
		else -- Highlight on hp
			self.highlight:ClearAllPoints()
			
			if db.showHpBar then
				self.highlight:SetAllPoints(self.hp)
			else
				self.highlight:SetAllPoints(self.hpNumber)
				
			end
		end
	end

	--ALPHA
	function u:alpha()

		if self.d.isTarget then
			self:SetAlpha(1)
		else
			if self.d.isTotem then
				self:SetAlpha(1)
			elseif self.d.hasRaidIcon then
				self:SetAlpha(1)
			elseif self.d.alphaIs<1 then
				self:SetAlpha(db.alpha)
			else
				self:SetAlpha(1)
			end
		end
	end
	
	--MOUSEOVER ALPHA
	function u:MouseoverAlpha()
--[[
		if self.d.isTarget then
			self:SetMouseoverAlpha(db.MoAlpha)
		else
			if self.d.isTotem then
				self:SetAlpha(1)
			elseif self.d.hasRaidIcon then
				self:SetAlpha(1)
			elseif self.d.alphaIs<1 then
				self:SetAlpha(1)
			else
				--self:SetMouseoverAlpha(0)
			end
		end]]
	end

	--TARGET AQUIRED HIGHLIGHT
	function u:mouseover() -- and target
		if self.d.isTarget then
			if not self.targetHighlight.visible then
				self.targetHighlight:ClearAllPoints()

				if not self.d.healthNotVisible then
					if db.showHpBar then
						--self.targetHighlight:SetPoint("TOPLEFT", self.hp, "TOPLEFT", -2, 2)
						--self.targetHighlight:SetPoint("BOTTOMRIGHT", self.hp, "BOTTOMRIGHT", 2, -2)
						--self.hp.border:SetBackdropBorderColor(0.5,0.5,0,1) -- yellow border around healthbar
						self.hp.border:SetBackdropBorderColor(1,1,1,1) -- white border around healthbar
					else
						self.targetHighlight:SetPoint("TOPLEFT", self.hpNumber, "TOPLEFT", -2, 2)
						self.targetHighlight:SetPoint("BOTTOMRIGHT", self.hpNumber, "BOTTOMRIGHT", 2, -2)
						self.targetHighlight:SetTexture("Interface\\Addons\\sqwNameplates\\media\\highlightTarget") 
						self.targetHighlight:Show() 
						self.targetHighlight.visible = true
					end
				else
					--[[----perminent nhl, overides deselect option settings! -- LINE BETWEEN PLAYER/NPC NAME &GUILD/TITLE
					self.targetHighlight:SetPoint("TOPLEFT", self.name, "TOPLEFT", -2, 2)
					self.targetHighlight:SetPoint("BOTTOMRIGHT", self.name, "BOTTOMRIGHT", 2, -2)
					self.targetHighlight:SetTexture("Interface\\Addons\\sqwNameplates\\media\\highlightTargetName") --remmed to hide line
					self.targetHighlight:Show() 
					self.targetHighlight.visible = true]]--
				end
			end
			
			if self.frameLevel~=22 then
				self:SetFrameLevel(22)
				self.frameLevel = 22
			end
		elseif self.d.isMouseover then --non target
		 if self.targetHighlight.visible then
            self.targetHighlight:Hide()
            self.targetHighlight.visible = false
        end
		
		--------------------------------->>> On mouseover creates either line under or box over name (added 28-06-2014) yup
		--[[
		self.targetHighlight:SetPoint("TOPLEFT", self.name, "TOPLEFT", -1, 4)
					self.targetHighlight:SetPoint("BOTTOMRIGHT", self.name, "BOTTOMRIGHT", 1, -2)
					
					]]--
		self.targetHighlight:SetPoint("TOPLEFT", self.name, "TOPLEFT", -12, 12)
					self.targetHighlight:SetPoint("BOTTOMRIGHT", self.name, "BOTTOMRIGHT", 12, -11)
					self.targetHighlight:SetTexture("Interface\\Addons\\sqwNameplates\\media\\RG")
					--self.targetHighlight:SetTexture("Interface\\Addons\\sqwNameplates\\media\\SoftOutline") --remmed to hide box over name
					--self.targetHighlight:SetTexture("Interface\\Addons\\sqwNameplates\\media\\highlight") --remmed to hide box over name
					--self.targetHighlight:SetTexture("Interface\\Addons\\sqwNameplates\\media\\highlightTargetName") --remmed to hide line under name
					self.targetHighlight:Show() 
					self.targetHighlight.visible = true
					--self.targetHighlight:SetVertexColor(0.5,0.5,0,1)--yellow
					self.targetHighlight:SetVertexColor(1,1,0,db.MoAlpha)--colour/alpha controls
		----------------------------------------------- <<<
		
		
			--[[if self.targetHighlight.visible then
				self.targetHighlight:Hide()
				self.targetHighlight.visible = false
			end]]
			
			if self.frameLevel~=24 then
				self:SetFrameLevel(24)
				self.frameLevel = 24
				 
			end
			
			self.hp.border:SetBackdropBorderColor(db.borderColor.r,db.borderColor.g,db.borderColor.b,db.borderColor.a) 
			
			self.d.GUID = UnitGUID("mouseover")
		else
		
			if self.targetHighlight.visible then
				self.targetHighlight:Hide()
				self.targetHighlight.visible = false
			end
			
			if self.frameLevel~=12 then
				self:SetFrameLevel(12)
				self.frameLevel = 12
			end
			
			self.hp.border:SetBackdropBorderColor(db.borderColor.r,db.borderColor.g,db.borderColor.b,db.borderColor.a)
			
		end
	end
	-----------------------------------------------------------
	--[[function u:npHLTexA()
		if not db.npHLTexA then
			if self.npHLTexA.visible then
				self.npHLTexA:Hide()
				self.npHLTexA.visible = false
			end
			else
			
				self.npHLTexA:Show()
				self.npHLTexA.visible = true
			
			return
		end
		end
		
		function u:npHLTexB()
		if not db.npHLTexB then
			if self.npHLTexB.visible then
				self.npHLTexB:Hide()
				self.npHLTexB.visible = false
			end
			else
			
				self.npHLTexB:Show()
				self.npHLTexB.visible = true
			
			return
		end]]
		--end
	--[[sqw
	function u:npmouseoverHL()
		local npHLTexa = true
	  
		if npHLTexa then
		npHLTex = frame:CreateTexture(npHLTex, "HIGHLIGHT")
		npHLTex:SetTexture("Interface\\Addons\\sqwNameplates\\media\\npHL") 
		npHLTex:SetVertexColor(1,1,.9,0.5)
		npHLTex:Show() 
		npHLTex.visible = true
		npHLTex:SetWidth(120)
		npHLTex:SetHeight(18)
		npHLTex:SetPoint("bottom" ,-2,2)
		else if npHLTexb then
		npHLTex:SetTexture("Interface\\Addons\\sqwNameplates\\media\\unknown") 
		npHLTex:SetVertexColor(1,1,1,1)
		npHLTex:Show() 
		npHLTex.visible = true
		npHLTex:SetWidth(120)
		npHLTex:SetHeight(8)
		npHLTex:SetPoint("bottom" ,0,3)
		else
		npHLTex:Hide()
		end
		end
	end]]
		


			-----------------------------------------------------------------------
	--AURAS
	function u:auras()
		if checkBuffsNotVisible(self.d) then
			for i=1,db.buffsNumber do
				if self.buffs[i].visible then
					self.buffs[i].expirationTime = 0
					self.buffs[i]:Hide()
					self.buffs[i].visible = false
				end
				
				if self.debuffs[i].visible then
					self.debuffs[i].expirationTime = 0
					self.debuffs[i]:Hide()
					self.debuffs[i].visible = false
				end
			end
			
			return
		end
		
		if addon.configMode then return end
		
		local GUID = self.d.GUID
		
		if GUID and guidBuffs[GUID] then
			for i=1,#guidBuffs[GUID] do
				if guidBuffs[GUID][i] then
					if guidBuffs[GUID][i].expirationTime and guidBuffs[GUID][i].expirationTime>0 and time>guidBuffs[GUID][i].expirationTime then
						tremove(guidBuffs[GUID], i)
					end
				end
			end
			
			sort(guidBuffs[GUID], function(a, b) 
				if a and b then 
					if a.priority==b.priority then
						if a.expirationTime==b.expirationTime then
							return a.name<b.name
						else
							return (a.expirationTime or 0)<(b.expirationTime or 0)
						end
					else
						return a.priority>b.priority
					end
				end 
			end)
			
			local counterBuffs = 1
			local counterDebuffs = 1
			for i=1,#guidBuffs[GUID] do
				if counterBuffs<=db.buffsNumber and guidBuffs[GUID][i].filter=="HELPFUL" then
					self.buffs[counterBuffs].spellName = guidBuffs[GUID][i].name or ""
					self.buffs[counterBuffs].expirationTime = guidBuffs[GUID][i].expirationTime or 0
					self.buffs[counterBuffs].duration = guidBuffs[GUID][i].duration or 1
					self.buffs[counterBuffs].count = guidBuffs[GUID][i].count or 0
					self.buffs[counterBuffs].filter = guidBuffs[GUID][i].filter
					
					local icon = "Interface\\Icons\\"..guidBuffs[GUID][i].icon
					if self.buffs[counterBuffs].icon.tex~=icon then
						self.buffs[counterBuffs].icon:SetTexture(icon)
						self.buffs[counterBuffs].icon.tex = icon
					end
					
					if not self.buffs[counterBuffs].visible then
						self.buffs[counterBuffs]:Show()
						self.buffs[counterBuffs].visible = true
					end
					local c = self.buffs[counterBuffs].count
					if c>1 then
						self.buffs[counterBuffs].counter:SetText(c)
					else
						self.buffs[counterBuffs].counter:SetText(nil)
					end
					local t = self.buffs[counterBuffs].expirationTime-time
					if t>0 then
						self.buffs[counterBuffs].time:SetText(formatTime(t))
					else
						self.buffs[counterBuffs].time:SetText(nil)
					end
					
					if guidBuffs[GUID][i].emphasize then
						if self.buffs[counterBuffs].size~=24 then
							self.buffs[counterBuffs]:SetWidth(24)
							self.buffs[counterBuffs]:SetHeight(24)
							self.buffs[counterBuffs].size = 24
						end
					else
						if self.buffs[counterBuffs].size~=12 then
							self.buffs[counterBuffs]:SetWidth(12)
							self.buffs[counterBuffs]:SetHeight(12)
							self.buffs[counterBuffs].size = 12
						end
					end
					
					counterBuffs = counterBuffs+1
				elseif counterDebuffs<=db.buffsNumber and guidBuffs[GUID][i].filter=="HARMFUL" then
					self.debuffs[counterDebuffs].spellName = guidBuffs[GUID][i].name or ""
					self.debuffs[counterDebuffs].expirationTime = guidBuffs[GUID][i].expirationTime or 0
					self.debuffs[counterDebuffs].duration = guidBuffs[GUID][i].duration or 1
					self.debuffs[counterDebuffs].count = guidBuffs[GUID][i].count or 0
					self.debuffs[counterDebuffs].filter = guidBuffs[GUID][i].filter
					
					local icon = "Interface\\Icons\\"..guidBuffs[GUID][i].icon
					if self.debuffs[counterDebuffs].icon.tex~=icon then
						self.debuffs[counterDebuffs].icon:SetTexture(icon)
						self.debuffs[counterDebuffs].icon.tex = icon
					end
					
					if not self.debuffs[counterDebuffs].visible then
						self.debuffs[counterDebuffs]:Show()
						self.debuffs[counterDebuffs].visible = true
					end
					local c = self.debuffs[counterDebuffs].count
					if c>1 then
						self.debuffs[counterDebuffs].counter:SetText(c)
					else
						self.debuffs[counterDebuffs].counter:SetText(nil)
					end
					local t = self.debuffs[counterDebuffs].expirationTime-time
					if t>0 then
						self.debuffs[counterDebuffs].time:SetText(formatTime(t))
					else
						self.debuffs[counterDebuffs].time:SetText(nil)
					end
					
					if guidBuffs[GUID][i].emphasize then
						if self.debuffs[counterDebuffs].size~=24 then
							self.debuffs[counterDebuffs]:SetWidth(24)
							self.debuffs[counterDebuffs]:SetHeight(24)
							self.debuffs[counterDebuffs].size = 24
						end
					else
						if self.debuffs[counterDebuffs].size~=12 then
							self.debuffs[counterDebuffs]:SetWidth(12)
							self.debuffs[counterDebuffs]:SetHeight(12)
							self.debuffs[counterDebuffs].size = 12
						end
					end
					
					counterDebuffs = counterDebuffs+1
				else
					break
				end
			end
			
			for i=counterBuffs,db.buffsNumber do
				if self.buffs[i].visible then
					self.buffs[i].expirationTime = 0
					self.buffs[i]:Hide()
					self.buffs[i].visible = false
				end
			end
			
			for i=counterDebuffs,db.buffsNumber do
				if self.debuffs[i].visible then
					self.debuffs[i].expirationTime = 0
					self.debuffs[i]:Hide()
					self.debuffs[i].visible = false
				end
			end
		else
			for i=1,db.buffsNumber do
				if self.buffs[i].visible then
					self.buffs[i].expirationTime = 0
					self.buffs[i]:Hide()
					self.buffs[i].visible = false
				end
				
				if self.debuffs[i].visible then
					self.debuffs[i].expirationTime = 0
					self.debuffs[i]:Hide()
					self.debuffs[i].visible = false
				end
			end
		end
	end

	--DEBUG
	function u:debug(frame)
		if not db.debugMode then 
			self.debug.bg:Hide()
			self.debug.text:SetText(nil)
			
			return
		else
			self.debug.bg:Show()
		end
		
		local text = ""
		
		text = text.."Frame: "
		text = text..tostring(self.number)
		text = text.."\n"
		
		text = text.."Updates: "
		text = text..tostring(self.uCounter)
		text = text.."\n"
		
		text = text.."Updates (hp): "
		text = text..tostring(self.uCounterHp)
		text = text.."\n"
		
		text = text.."Updates (threat): "
		text = text..tostring(self.uCounterThreat)
		text = text.."\n"
		
		text = text.."Updates (aura): "
		text = text..tostring(self.uCounterAura)
		text = text.."\n"
		
		text = text.."Updates (cast): "
		text = text..tostring(self.uCounterCast)
		text = text.."\n"
		
		text = text.."GUID: "
		text = text..tostring(self.d.GUID)
		text = text.."\n"
		
		text = text.."Threat: "
		text = text..tostring(tostring(self.d.threatPercent).." ("..tostring(self.d.threatState)..")".." ("..tostring(self.d.threatIsTanked)..")")  --self.d.threatIsTanked
		text = text.."\n"
		
		if self.d.GUID and guidBuffs[self.d.GUID] then
			text = text.."Buffs: "
			for i=1,#guidBuffs[self.d.GUID] do
				if guidBuffs[self.d.GUID][i].filter=="HELPFUL" then
					text = text.."("..i..")"..tostring(guidBuffs[self.d.GUID][i].name)..", "
				end
			end
			text = text.."\n"
			
			text = text.."Debuffs: "
			for i=1,#guidBuffs[self.d.GUID] do
				if guidBuffs[self.d.GUID][i].filter=="HARMFUL" then
					text = text.."("..i..")"..tostring(guidBuffs[self.d.GUID][i].name)..", "
				end
			end
			text = text.."\n"
		end
		
		self.debug.text:SetText(text)
	end


	--CREATE NAMEPLATE 
	local overlayType = "Texture"
	local overlayBorderTexture = "Interface\\Tooltips\\Nameplate-Border"
	local function isValidFrame(frame)
		
		local barFrame, _ = frame:GetChildren()
		if barFrame then
			local overlayRegion = select(2, barFrame:GetRegions())

			if overlayRegion and overlayRegion.GetTexture and overlayRegion:GetTexture() == overlayBorderTexture then

				-- if overlayRegion and overlayRegion:GetObjectType()==overlayType and overlayRegion:GetTexture()==overlayBorderTexture then
				frame.isNameplate = true
				return true
			end
		end  
		return false 

	end

	local function onCreateChildFrames(...)
		for i=1, select("#", ...) do 
			local frame = select(i, ...)
			if isValidFrame(frame) and not frame.np then addon.createNewNameplate(frame) end
		end
	end

	--NAMEPLATE ON UPDATE
	local nameplatesUpdater = CreateFrame("Frame", nil, WorldFrame)
	nameplatesUpdater:SetFrameStrata("TOOLTIP") 
	local lastUpdateThreat = 0
	local lastUpdateTankMode = 0
	local wframe = WorldFrame
	local numChildren = -1

	local function onUpdate(self, elapsed) -- onUpdate
		lastUpdateThreat = lastUpdateThreat + elapsed;
		lastUpdateTankMode = lastUpdateTankMode + elapsed;
		
		if true then -- No delay allowed
			local curChildren = wframe:GetNumChildren()
			if curChildren~=numChildren then numChildren = curChildren onCreateChildFrames(wframe:GetChildren())
			end
			
			if playerTarget then
				for index,value in pairs(framesShown) do
					local alpha = value:GetAlpha()
					
					value.np.alpha = alpha or 1 -- Set nameplate alpha.
					if alpha~=1 then value:SetAlpha(1) end -- Set to 1 to allow child frames to use their full alpha range.
				end
			end
			
			for i=#doUpdateNext.frames,1,-1 do
				uNameplate(doUpdateNext.frames[i][1], doUpdateNext.frames[i][2])
				tremove(doUpdateNext.frames, i)
			end
			
			for i=#doUpdateNext.name,1,-1 do
				uNameplateByName(doUpdateNext.name[i][1], doUpdateNext.name[i][2])
				tremove(doUpdateNext.name, i)
			end
			
			for i=#doUpdateNext.GUID,1,-1 do
				uNameplateByGUID(doUpdateNext.GUID[i][1], doUpdateNext.GUID[i][2])
				tremove(doUpdateNext.GUID, i)
			end

			if doUpdateThreat>0 then
				doUpdateThreat = doUpdateThreat-1
				
				for index,value in pairs(framesShown) do
					uNameplate(value, "onlyThreat")
				end
			end
			
			if doUpdate>0 then
				doUpdate = doUpdate-1
				
				for index,value in pairs(framesShown) do
					uNameplate(value)
				end
			end
		end
		
		if inCombat and lastUpdateThreat>1 then
			local unitId
			
			if UnitInRaid("player") then
				unitId = "raid"
				groupSize = GetNumGroupMembers()-1
			elseif UnitInParty("player") then
				unitId = "party"
				groupSize = GetNumGroupMembers()
			end
			
			if unitId then
				for i=1,groupSize do
					addon:UNIT_THREAT_LIST_UPDATE("UNIT_THREAT_LIST_UPDATE (onUpdate)", unitId..i.."target")
				end
			end
			
			lastUpdateThreat = 0
		end
		
		if lastUpdateTankMode>5 then
			checkTankMode()
			
			lastUpdateTanks = 0
		end
	end

	--EVENTS
	function addon:PLAYER_LEVEL_UP()
		playerLevel = UnitLevel("player")
	end

	function addon:UPDATE_MOUSEOVER_UNIT()
		if UnitExists("mouseover") then
		
			
			scanUnitAuras("mouseover", playerTargetGUID)
			
			local GUID = UnitGUID("mouseover")
			local name, rlm = UnitName("mouseover")
			
			
			if not inCombat then
				local isPlayer = UnitIsPlayer("mouseover")
				local reaction = UnitReaction("mouseover", "player") -- 4 is neutral
				
				if not isPlayer then
					sqwScanningTooltip:ClearLines()
					sqwScanningTooltip:SetUnit("mouseover")
					local text = sqwScanningTooltipTextLeft3:GetText()
					
					if text then
						_, text = strsplit(" ", text)
						
						if text=="??" or tonumber(text) then
							global.npcList[name] = sqwScanningTooltipTextLeft2:GetText()
						else
							global.npcList[name] = "NONE"
						end
					else
						global.npcList[name] = "NONE"
					end
					
					if UnitClassification("mouseover")=="worldboss" then collectUnitInfo("mouseover") end
				else
					collectUnitInfo("mouseover")
				end
			else
				collectUnitInfo("mouseover")
				
				addon:UNIT_THREAT_LIST_UPDATE("UNIT_THREAT_LIST_UPDATE", "mouseover")
			end
			
			if UnitCastingInfo("mouseover") or UnitChannelInfo("mouseover") then addon:UNIT_SPELLCAST_START("UNIT_SPELLCAST_START", "mouseover") end
			
			--setDoUpdateMe(name, "name") -- We have to delay it or every plate with that name will be the target.
		end
		
		setDoUpdate(1)
	end


	function addon:PLAYER_REGEN_ENABLED()
		inCombat = false
		
		wipe(guidCasts)
		
		setVisibility()
		softReset()
	end

	function addon:PLAYER_REGEN_DISABLED()
		inCombat = true
		
		wipe(guidCasts)
		
		setVisibility()
		softReset()
	end

	function addon:PLAYER_TARGET_CHANGED()
		if UnitExists("target")==1 then
			playerTarget = UnitName("target") or "UNKNOWN"
			playerTargetGUID = UnitGUID("target")
			
			collectUnitInfo("target")
			
			scanUnitAuras("target", playerTargetGUID)
			
			if UnitCastingInfo("target") then addon:UNIT_SPELLCAST_START("UNIT_SPELLCAST_START", "target") end
			
			addon:UNIT_THREAT_LIST_UPDATE("UNIT_THREAT_LIST_UPDATE", "target")
		else
			playerTarget = false
			playerTargetGUID = nil
			
			for index,value in pairs(framesShown) do
				value.np.alpha = 1 -- Reset nameplate alpha
			end
		end
		
		softReset()
	end

	function addon:RAID_TARGET_UPDATE()
		for i=1,#frames do
			frames[i].np.d.hasRaidIcon = false
			
			if frames[i].np.raidIcon.visible then
				frames[i].np.raidIcon:Hide()
				frames[i].np.raidIcon.visible = false
			end
		end
		
		setDoUpdate(1)
	end

	function addon:UNIT_TARGET(event, unit) 
		if not UnitExists(unit) or UnitIsUnit("player", unit) then return end
		
		local unitTarget = unit.."target"
		local raidIconIndex = GetRaidTargetIndex(unitTarget)
		
		if raidIconIndex and raidIconIndex>0 then
			uNameplateByRaidIcon(raidIconIndex, UnitGUID(unitTarget))
		end
		
		if UnitIsPlayer(unitTarget) then
			collectUnitInfo(unitTarget)
			
		end
		
		if isInArena and strfind(unit, "arena") then
			SetCVar("nameplateShowFriends", 0)--sqw added
			local GUID = UnitGUID(unit)
			
			for index,value in pairs(frames) do
				if GUID and value.np.d.GUID and GUID==value.np.d.GUID then
					if unitTarget then
						value.np.d.tot = UnitName(unitTarget)
						_, value.np.d.totClass = UnitClass(unitTarget)
					else
						value.np.d.tot = nil
					end
					
					uNameplate(value, option)

					return
				end
			end
		end
		
		addon:UNIT_THREAT_LIST_UPDATE("UNIT_THREAT_LIST_UPDATE (UNIT_TARGET)", unitTarget)
	end

	function addon:UNIT_THREAT_LIST_UPDATE(event, unit)
		--p(GetTime().."  "..event.."  "..tostring(unit))
		if not UnitExists(unit) then return end
		
		local unitId, groupSize
		if UnitInRaid("player") then
			unitId = "raid"
			groupSize = GetNumGroupMembers()-1
		elseif UnitInParty("player") then
			unitId = "party"
			groupSize = GetNumGroupMembers()
		end
		
		if not unitId then return end
		
		local _, _, player = UnitDetailedThreatSituation("player", unit)
		
		if not player then return end
		
		local groupMember = 0
		local isTanked = false
		for i=1,groupSize do
			local id = unitId..i
			
			local _, _, threat = UnitDetailedThreatSituation(id, unit)
			
			if threat and threat>groupMember then groupMember = threat end
			
			if threat and tanks[id] and threat>player then isTanked = true end
		end
		
		if player and groupMember then
			local GUID = UnitGUID(unit)
			
			guidThreat[GUID] = guidThreat[GUID] or {}
			guidThreat[GUID].player = player
			guidThreat[GUID].groupMember = groupMember
			guidThreat[GUID].isTanked = isTanked
		end
		
		setDoUpdateThreat(1)
	end


	--[[local checkStatus = function()
	  local name, type, difficulty, difficultyName, maxPlayers, playerDifficulty, isDynamicInstance = GetInstanceInfo()
	  if type = "party" and GetNumGroupMembers() > 0 and not UnitInRaid("player") then
		print("I'm in a party")
	  end
	end
	 
	local a = CreateFrame("Frame")
	a:SetScript("OnEvent", checkStatus)
	a:RegisterEvent("PLAYER_ENTERING_WORLD")
	a:RegisterEvent("PARTY_MEMBERS_CHANGED")]]

	--ZONE CHECKS
	local zoneCheckFrame = CreateFrame("Frame", nil, WorldFrame)
	zoneCheckFrame:SetFrameStrata("TOOLTIP")
	zoneCheckFrame:Hide()
	zoneCheckFrame.lastUpdate = 0
	--local function zoneCheckFrameOnUpdate(self, elapsed) -- Checks what type of instance we are in
		local function zoneCheckFrameOnUpdate() -- Checks what type of instance we are in
			local instanceName, instanceType, difficulty, _, maxPlayers, playerDifficulty, isDynamicInstance = GetInstanceInfo()
			--	local type = instanceType
			--[[
			if self.lastUpdate+elapsed>self.lastUpdate+1 then
			self.lastUpdate = 0
			else
			self.lastUpdate = self.lastUpdate+elapsed
			end

			if self.lastUpdate>5 then
			self:Hide()
			
			setVisibility() 
			softReset()
			
			return
			elseif self.lastUpdate>1 then]]
			local isIn, type = IsInInstance()
			isInInstance = type or "none"
			isInSanctuary = UnitIsPVPSanctuary("player")
			hasGroup = GetNumGroupMembers()>1 or false
			
			if type=="pvp" then
				isInBattleground = true
				isInPvp = true
				isInPve = false
			elseif type=="arena" then
				isInArena = true
				isInPvp = true
				isInPve = false
			else
				isInPve = true
				isInPvp = false
				isInArena = false
				isInBattleground = false
				--end
			end
		end
	zoneCheckFrame:HookScript("OnUpdate", zoneCheckFrameOnUpdate)
	local function zoneCheck()
		if GetGuildInfo("player") then GuildRoster() end 
		zoneCheckFrame.lastUpdate = 0
		zoneCheckFrame:Show()
	end

	function addon:ZONE_CHANGED()
		zoneCheck()
	end

	function addon:ZONE_CHANGED_INDOORS()
		zoneCheck()
	end

	function addon:ZONE_CHANGED_NEW_AREA()
		zoneCheck()
		
		wipe(temporaryList)
		wipe(guidCasts)
		
		if db.combatLogFix then CombatLogClearEntries() end
	end

	addon.raid = {}
	addon.tanks = {}
	local function checkRaidMembers()
		local raid = addon.raid
		
		wipe(raid)
		wipe(tanks)
		
		for i=1,GetNumGroupMembers() do
			local unit = "raid"..i
			
			collectUnitInfo(unit)
			
			local GUID = UnitGUID(unit)
			local name, rlm = UnitName(unit)
			local _, class = UnitClass(unit)
			local guildName = GetGuildInfo(unit)
			
			if GUID then
				raid[GUID] = raid[GUID] or {}
				
				raid[GUID].name = name
				raid[GUID].class = class
				raid[GUID].realm = rlm or realmName
				raid[GUID].guild = guildName or "NONE"
				raid[GUID].unit = unit
				
				raid[name] = GUID
				raid[unit] = name
				
				local _, _, _, _, _, _, _, _, _, role, _ = GetRaidRosterInfo(i)
				if role=="MAINTANK" then
					tanks[unit] = name
					tanks[name] = unit
				end
			end
		end
		
		setDoUpdate(1)
	end

	addon.party = {}
	local function checkPartyMembers()
		local party = addon.party
		
		wipe(party)
		
		for i=1,GetNumGroupMembers() do
			local unit = "party"..i
			
			collectUnitInfo(unit)
			
			local GUID = UnitGUID(unit)
			local name, rlm = UnitName(unit)
			local _, class = UnitClass(unit)
			local guildName = GetGuildInfo(unit)
			
			if GUID then
				party[GUID] = party[GUID] or {}
				
				party[GUID].name = name
				party[GUID].class = class
				party[GUID].realm = rlm or realmName
				party[GUID].guild = guildName or "NONE"
				party[GUID].unit = unit
				
				party[name] = GUID
				party[unit] = name
			end
		end
		
		hasGroup = GetNumGroupMembers()>1 or false
		
		setDoUpdate(1)
	end

	addon.arena = {}
	local function checkArenaMembers()
		local arena = addon.arena
		
		wipe(arena)
		
		local i = 1
		while UnitExists("arena"..i) do
			local unit = "arena"..i
			
			collectUnitInfo(unit)
			
			local GUID = UnitGUID(unit)
			local name, rlm = UnitName(unit)
			local _, class = UnitClass(unit)
			local guildName = GetGuildInfo(unit)
			
			arena[GUID] = arena[GUID] or {}
			
			arena[GUID].name = name
			arena[GUID].class = class
			arena[GUID].realm = rlm or realmName
			arena[GUID].guild = guildName or "NONE"
			arena[GUID].unit = unit
			
			arena[name] = GUID
			arena[unit] = name
			
			i = i+1
		end
		
		setDoUpdate(1)
	end

	addon.battleground = {}

	addon.guild = {}
	local function checkGuildMembers()
		wipe(addon.guild)
		
		for i=1,GetNumGuildMembers() do
			local name = GetGuildRosterInfo(i)
			
			if name then addon.guild[name] = true end
		end
	end

	addon.bnet = {}
	local function checkBnetFriends()
		wipe(addon.bnet)
		
		for i=1,BNGetNumFriends() do
			local presenceID, givenName, surname, toonName = BNGetFriendInfo(i)
			
			if toonName then addon.bnet[toonName] = true end
		end
	end

	addon.friend = {}
	local function checkFriendMembers()
		wipe(addon.friend)
		
		for i=1,GetNumFriends() do
			local name = GetFriendInfo(i)
			
			if name then addon.friend[name] = true end
		end
	end

	function addon:RAID_ROSTER_UPDATE()
		checkRaidMembers()
		checkPartyMembers()
		checkGuildMembers()
		checkFriendMembers()
		checkBnetFriends()
		checkArenaMembers()
		
		setDoUpdate(1)
	end
	function addon:PARTY_MEMBERS_CHANGED()
		checkRaidMembers()
		checkPartyMembers()
		checkGuildMembers()
		checkFriendMembers()
		checkBnetFriends()
		checkArenaMembers()
		
		setDoUpdate(1)
	end
	function addon:GUILD_ROSTER_UPDATE()
		checkRaidMembers()
		checkPartyMembers()
		checkGuildMembers()
		checkFriendMembers()
		checkBnetFriends()
		checkArenaMembers()
		
		setDoUpdate(1)
	end
	function addon:FRIENDLIST_UPDATE()
		checkRaidMembers()
		checkPartyMembers()
		checkGuildMembers()
		checkFriendMembers()
		checkBnetFriends()
		checkArenaMembers()
		
		setDoUpdate(1)
	end
	function addon:BN_FRIEND_TOON_ONLINE()
		checkRaidMembers()
		checkPartyMembers()
		checkGuildMembers()
		checkFriendMembers()
		checkBnetFriends()
		checkArenaMembers()
		
		setDoUpdate(1)
	end

	function addon:PLAYER_ENTERING_WORLD()
		checkRaidMembers()
		checkPartyMembers()
		checkGuildMembers()
		checkFriendMembers()
		checkBnetFriends()
		checkArenaMembers()
		
		zoneCheck()
		
		if db.combatLogFix then CombatLogClearEntries() end
		
		setDoUpdate(1)
		end

	function addon:PLAYER_LOGIN()
		checkRaidMembers()
		checkPartyMembers()
		checkGuildMembers()
		checkFriendMembers()
		checkBnetFriends()
		checkArenaMembers()
		
		zoneCheck()
		
		if db.combatLogFix then CombatLogClearEntries() end
		
		setDoUpdate(1)
	end

	--INITIALISE
	function addon:initializeUpdater()
		--Variables
		db = addon.db.profile
		realm = addon.db.realm
		global = addon.db.global
		playerList = realm.playerList
		raid = addon.raid
		party = addon.party
		guild = addon.guild
		bnet = addon.bnet
		friend = addon.friend
		arena = addon.arena
		battleground = addon.battleground
		isTank = addon.isTank
		guidBuffs = addon.GUIDBuffs
		guidCasts = addon.GUIDCasts
		scanUnitAuras = addon.scanUnitAuras
		frames = addon.frames
		tanks = addon.tanks
		
		isInPvp = false
		isInPve = true
		local _, type = IsInInstance()
		isInInstance = type or "none"
		isInBattleground = false
		isInArena = false
		isInSanctuary = false
		hasGroup = false
		
		-- Events.  "CURSOR_UPDATE" fires too often
		self:RegisterEvent("PLAYER_REGEN_ENABLED")
		self:RegisterEvent("PLAYER_REGEN_DISABLED")
		self:RegisterEvent("PLAYER_TARGET_CHANGED")
		self:RegisterEvent("RAID_TARGET_UPDATE")
		self:RegisterEvent("UNIT_THREAT_LIST_UPDATE")
		self:RegisterEvent("UPDATE_MOUSEOVER_UNIT")
		self:RegisterEvent("ZONE_CHANGED")
		self:RegisterEvent("ZONE_CHANGED_INDOORS")
		self:RegisterEvent("ZONE_CHANGED_NEW_AREA")
		self:RegisterEvent("PLAYER_ENTERING_WORLD")
		self:RegisterEvent("PLAYER_LOGIN")
		self:RegisterEvent("PLAYER_LEVEL_UP")
		self:RegisterEvent("UNIT_TARGET")
		self:RegisterEvent("RAID_ROSTER_UPDATE")
		self:RegisterEvent("PARTY_MEMBERS_CHANGED")
		self:RegisterEvent("GUILD_ROSTER_UPDATE")
		self:RegisterEvent("FRIENDLIST_UPDATE")
		self:RegisterEvent("BN_FRIEND_TOON_ONLINE")
		
		-- Other files
		addon:initializeAuras()
		addon:initializeCast()
		
		-- OnUpdate
		nameplatesUpdater:HookScript("OnUpdate", onUpdate)
		setDoUpdate(1)
	end